do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_SECRET35_Banner_GBS = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SECRET35_Banner_GBS
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0.25
		self.tex_y1=1/8.0
	end
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_SECRET35_Banner_Drawable.new()
		self.drawable:Setup(self,self.environment)
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		if(self.alivetime>0.5+4.0)then
			self:Die()
		end
	end	
end

do
	local super=TRAININGGROUNDS_SECRET35_Banner_GBS
	TRAININGGROUNDS_SECRET35_Banner_GRS = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SECRET35_Banner_GRS
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0.25
		self.tex_y1=2/8.0
	end
end


do
	local super=TRAININGGROUNDS_SECRET35_Banner_GBS
	TRAININGGROUNDS_SECRET35_Banner_Perfect = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SECRET35_Banner_Perfect
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.tex_y1=3/8.0
	end
end

do
	local super=TRAININGGROUNDS_Drawable
	TRAININGGROUNDS_SECRET35_Banner_Drawable = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SECRET35_Banner_Drawable
	
	function class:CreateFrame()
		self.frames={}
		self.frame=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.frame:Show()
		tinsert(self.frames,self.frame)
		self.left=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.left:Show()
		tinsert(self.frames,self.left)
		self.right=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.right:Show()
		tinsert(self.frames,self.right)
	end
	
	local WIDTH,HEIGHT=600,75
	function class:SetFrameAppearance()			
		self.frame:SetSize(WIDTH,HEIGHT)
		self.frame.texture:Hide()
		self.left:SetParent(self.frame)
		self.left:SetSize(WIDTH/2,HEIGHT)
		self.left:SetPoint("RIGHT",self.frame,"CENTER",0,0)
		self.left.texture:Show()
		self.left.texture:SetTexture("Interface\\AddOns\\TrainingGrounds_GetSpheres\\Assets\\Graphics\\HUD.tga")
		self.left.texture:SetTexCoord(0,self.owner.tex_y1,0,self.owner.tex_y1+1/8,1/2,self.owner.tex_y1,1/2,self.owner.tex_y1+1/8)		
		self.left:SetAlpha(1)
		self.right:SetParent(self.frame)
		self.right:SetSize(WIDTH/2,HEIGHT)
		self.right:SetPoint("LEFT",self.frame,"CENTER",0,0)
		self.right.texture:Show()
		self.right.texture:SetTexture("Interface\\AddOns\\TrainingGrounds_GetSpheres\\Assets\\Graphics\\HUD.tga")
		self.right.texture:SetTexCoord(1/2,self.owner.tex_y1,1/2,self.owner.tex_y1+1/8,1,self.owner.tex_y1,1,self.owner.tex_y1+1/8)		
		self.right:SetAlpha(1)		
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.shadowframelayer
	end		
	function class:ArrangeFrame(parentanchor,cposx,cposy,cposz,cangx,cangy,cangz)
		self.frame:ClearAllPoints()		
		self.frame:SetParent(self.parentframe)
		local x=0
		local y=0
		self.frame:SetPoint(self.anchor,self.parentframe,parentanchor,x,y)		
		self:SetFrameSizeAndOrientation(WIDTH,HEIGHT,yaw,-math.pi/2+0.75,1)
		local distance=0
		if(self.owner.alivetime>=0.25 and self.owner.alivetime<=3.0)then
			distance=0
		elseif(self.owner.alivetime>3.75)then
			distance=2400*(self.owner.alivetime-3.75)
		elseif(self.owner.alivetime<0.25)then
			distance=2400*(0.25-self.owner.alivetime)
		end
		self.left:SetPoint("RIGHT",self.frame,"CENTER",-distance,0)
		self.right:SetPoint("LEFT",self.frame,"CENTER",distance,0)
		
		self.left:SetFrameLevel(254)
		self.right:SetFrameLevel(254)
	end	
end