do
	local super=TRAININGGROUNDS_Camera
	TRAININGGROUNDS_SECRET35_Camera_35Spheres = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SECRET35_Camera_35Spheres

		--MAX_BILLBOARD_GROUNDCLIP_DISTANCE is slightly broken, needs to be fixed in drawable_worldgrid
	--MAX_BILLBOARD_GROUNDCLIP_DISTANCE=6.5		-- was ok, but became too high after we broke things
	--MAX_BILLBOARD_GROUNDCLIP_DISTANCE=6		-- not necessarily too low
		MAX_BILLBOARD_GROUNDCLIP_DISTANCE=6.25		-- remember, world framelevel is only set once, on startup...		
		WORLD_SCALE_MULTIPLIER=300
		sphereradius=10.5
		far=2.25
		screenoffsety=25		--negative values shift the grid UP
		HZ_CAMERA_DISTANCE=0		-- we've tried using 1, but 0 is fine for now
		CAMERA_HEIGHT=-0.6		--TODO: this number currently has to be negative for everything to work, but shouldn't height be positive?
	
	
	function class:CreateFrameLayers()
		local ysortframelevel=170		
		local worldgridframelevel=50
		self.ysortframelevel=ysortframelevel
		self.gridframelevel=gridframelevel
		local layer=ysortframelevel
		-- characters and shadows on top
		self.ysortframelayer=TRAININGGROUNDS_FrameLayer.QuickSetup(layer)		
		layer=layer-1
		self.shadowframelayer=TRAININGGROUNDS_FrameLayer.QuickSetup(layer)		
		-- world grid ranges from 50-165ish.
		-- TODO LATER: recalculate framelevel from GRID_SIZE instead of hardcoding it, maybe
		layer=worldgridframelevel
		self.worldgridframelevel=TRAININGGROUNDS_FrameLayer.QuickSetup(layer)
		layer=layer-1
		-- telegraphs, voidzones, etc are placed below the first ysorted object
		self.movementarrowframelayer=TRAININGGROUNDS_FrameLayer.QuickSetup(layer)
		layer=layer-1
		self.telegraphframelayer=TRAININGGROUNDS_FrameLayer.QuickSetup(layer)
		layer=layer-1
		self.voidzoneframelayer=TRAININGGROUNDS_FrameLayer.QuickSetup(layer)
		layer=layer-1
		self.targetcircleframelayer=TRAININGGROUNDS_FrameLayer.QuickSetup(layer)
		-- arena shape needs 2 layers (one for border, one for fill)
		layer=layer-1
		layer=layer-1
		self.arenaborderframelayer=TRAININGGROUNDS_FrameLayer.QuickSetup(layer)
		
		self.defaultframelayer=TRAININGGROUNDS_FrameLayer.QuickSetup(100)
	end
	
	
	
	function class:ArrangeAllGameObjects(objs)

		if(not self.rot)then self.rot=0 end

		self:SetScrollAndZoom()
		
		
		local scenario=self.environment.game.scenario
		local player=scenario.player
			

		
		--TODO NEXT: affix TRAININGGROUNDS_Secret35_ prefix to global vars, or make vars not-global
		

		
		--for the desired perspective, we can adjust the following:
		-- "far" (TODO: rename to perspective_squish or something)
		-- sphereradius
		-- camera angle
		-- camera position
		-- world_scale_multiplier				
		
		
		-- camera angle, X axis: what we think of as "vertical tilt"
			-- 0: straight down.  pi/2: straight forward*
				-- * note that due to sphere curvature, camera can't get close to pi/2 without causing problems
		local cangx=0.75
		local cangy=0
		local cangz=player.grid_facing-math.pi/2		-- camera angle, Z axis: used to turn "horizontally".
		local cposz=CAMERA_HEIGHT
		
		

		local cposx=player.x
		local cposy=player.y
		local coffsetx=0
		local coffsety=0
		local coffsetx=math.sin(cangz)*HZ_CAMERA_DISTANCE
		local coffsety=math.cos(cangz)*HZ_CAMERA_DISTANCE

		
		
		
		for i=1,#objs,1 do
			local obj=objs[i]		
			--"obj.drawable" is the Drawable to be drawn (i.e. we're checking "does such a drawable exist")
			if(obj.drawable)then
				--"obj.visible" is a property (i.e. we're checking "is this drawable currently visible")
				if(obj.drawable.visible)then				
					if(not obj.drawable.frame) then
						error("Object ",obj," drawable ",obj.drawable," does not have a frame (did we forget to run setup?)")
					end				

					local x,y=(obj.drawable.x),(obj.drawable.y)*self.ystretch
					y=y+(obj.screenyoffset)
					y=y+(obj.drawable.z)*self.zstretch
					
					if(TRAININGGROUNDS_Scrollframes_Broken)then
						x=x-hscroll
						y=y-vscroll
					end
											
					local wid,hgt=obj.drawable.width,obj.drawable.height
					local yaw,pitch=obj.currentfacing,self.heightangle

					obj.drawable:ArrangeFrame(self.objectanchor,cposx,cposy,cposz,cangx,cangy,cangz,coffsetx,coffsety)
									
					obj.drawable:ShowFrames()
				

				else	-- end visible check
					obj.drawable:HideFrames()
					--obj.drawable.frame:SetAlpha(0)
				end
			end	-- end drawable-exists check
		end		-- end arrange loop
		
		
		local toplayer=self.ysortframelevel
		if(self.ysort) then		
			if(self.environment.game.realtime>self.nextysorttime)then
				self.nextysorttime=self.environment.game.realtime+self.nextysortinterval
				local tempysort={}
				for i=1,#objs,1 do 
					if(objs[i].ysortable==true)then
						tinsert(tempysort,objs[i]) 					
					end
				end
				table.sort(tempysort, function(a,b) return a.y>b.y end)			
				for k,v in ipairs(tempysort) do 	
					v.drawable:SetSortedFrameLevels(toplayer)
					toplayer=toplayer+1
				end
			end		
		end
		
		if((not self.postysortframelevel) or toplayer>self.postysortframelevel)then self.postysortframelevel=toplayer end
		
	
		for i=1,#objs,1 do 
			if(not objs[i].ysortable)then
				if(objs[i].drawable.updateframelevel)then
					objs[i].drawable:SetFrameLevel()
					objs[i].drawable.updateframelevel=false
				end			
			end
		end

	end
end