do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_SECRET35_GameObject_Follower35 = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SECRET35_GameObject_Follower35
	
	function class:Setup(environment,scenario)
		super.Setup(self,environment,scenario)
		self.scenario=scenario
		self.alpha=1		
		self.spinpitch=0
		self.queuedstartjumptime=nil
		self.queuedendjumptime=nil
		self.queuedspringed=nil
		self.startjumptime=nil
		self.endjumptime=nil
		self.springed=nil
	end

	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_SECRET35_Drawable_Follower35.new()
		self.drawable:Setup(self,self.environment)
	end	
	
	function class:EffectiveSpeedMultiplier()
		return self.hedge:EffectiveSpeedMultiplier()
	end
	
	function class:PreDraw(elapsed)
		self.currenttime=self.hedge.currenttime
		
		if(self.queuedstartjumptime~=nil and self.currenttime>=self.queuedstartjumptime)then
			self.startjumptime=self.queuedstartjumptime
			self.endjumptime=self.queuedendjumptime
			self.springed=self.queuedspringed
			self.queuedstartjumptime=nil
			self.queuedendjumptime=nil
			self.queuedspringed=nil
		end
		
		local alpha=1.0
	
		if(self.endjumptime)then
			if(self.currenttime>=self.endjumptime)then
				self.endjumptime=nil
				self.z=0
			else
				local t=(self.endjumptime-self.currenttime)/(self.endjumptime-self.startjumptime)*math.pi
				local heightmultiplier=math.sin(t)
				if(self.springed)then
					heightmultiplier=heightmultiplier*2.25
				end
				local effectivespeedmultiplier=self.hedge:EffectiveSpeedMultiplier()		
				local divisor=effectivespeedmultiplier
				if(divisor>1)then
					divisor=1+math.log(divisor)				
				end
				self.z=heightmultiplier*4/effectivespeedmultiplier
			end
		else
			self.z=0
		end		
		TRAININGGROUNDS_GameObject.PreDraw(self,elapsed)
	end
	
	local JUMP_DELAY=4/60.0
	
	
	-- call QueueJump/QueueSpring at the end of StartJump/Spring.OnInteract, after the player's jump has been set up.
	function class:QueueJump()				
		self.queuedstartjumptime=self.hedge.startjumptime+JUMP_DELAY
		self.queuedendjumptime=self.hedge.endjumptime+JUMP_DELAY
		self.queuedspringed=false
	end
	
	function class:QueueSpring()
		self.queuedstartjumptime=self.hedge.startjumptime+JUMP_DELAY
		self.queuedendjumptime=self.hedge.endjumptime+JUMP_DELAY
		self.queuedspringed=true		
	end
	
	

end

do
	local super=TRAININGGROUNDS_Drawable_CharacterModel
	TRAININGGROUNDS_SECRET35_Drawable_Follower35 = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SECRET35_Drawable_Follower35
	
	function class:CreateFrame()
		self.frame=TRAININGGROUNDS_ReusableModelFrames:GetFrame()
		self.frame:Show()
	end
	
	local QuickTryOn=function(self,itemid)		
		local link=TRAININGGROUNDS_Equipment_GetItemTooltip(itemid)
		self.frame:TryOn(link)
	end

	function class:SetFrameAppearance()	
		self.modelinfo=TRAININGGROUNDS_ModelInfo.new()
		self.modelinfo:Setup()
	
		self.frame:SetDisplayInfo(81018)	--Kiro
		
		self:SetLighting(1,1,1,1,0.6,1,1,1)	
	end
	
	function class:SetAnimationSystem()
		self.animationsystem=TRAININGGROUNDS_Secret35_FollowerAnimationSystem.new()
		self.animationsystem:Setup(self)
	end
	
	
	function class:ArrangeFrame(parentanchor,cposx,cposy,cposz,cangx,cangy,cangz)
		self.frame:ClearAllPoints()
			
		self.frame:SetParent(self.parentframe)
		
	
		local ground_x,ground_y=0,-127.7-64-32
		local height_y=self.owner.z*50		--TODO: this *50 is arbitary and .z already has a multipler attached to it
													-- see if we can change .z to work in gridtile_units

													
		local offset_y=-0
		local x,y=ground_x,ground_y+height_y+offset_y
		
		self.frame:SetPoint(self.anchor,self.parentframe,parentanchor,x,y)		
		
		local yaw=math.pi/2--self.owner.currentfacing
		local pitch=-math.pi/3
		--self:SetFrameSizeAndOrientation(150,150,yaw,-math.pi/2+0.75,1)
		--self:SetFrameSizeAndOrientation(190,190,yaw,-math.pi/2+0.75,1)
		--self:SetFrameSizeAndOrientation(190,190,yaw,self.owner.spinpitch,1)
		self:SetFrameSizeAndOrientation(190*1.4,190*1.4,yaw,-math.pi/2+0.75,1)
		self.frame:SetPitch(self.owner.spinpitch)
		--print("Spinpitch:",self.owner.spinpitch)

		--self.frame:SetLight(true,false, -.5, 0, -.5,
		self.frame:SetLight(true,false, -1, 0, 0,
						self.lightAA,self.lightAR,self.lightAG,self.lightAB,
						self.lightDA,self.lightDR,self.lightDG,self.lightDB)		
						
		-- self.frame.texture:Show()--!!!
		self.frame:SetFrameLevel(175+1)
	end
	
	
	

	
end