--TODO: gridbuildingmodule is somehow mirrored around x-axis
-- ...drawing or facing code may be wildly off.

	
--------------------------------------------------------------------------------------------------------
	
--TODO NEXT: drawable_worldgrid billboard texture picker needs to pass currenttime to sphere

--TODO: rename shadow and shadow's filenames to match their classnames

--TODO: now that we have a good look at them, sphere size appears to change linearly and then plateau when we get near enough
	-- double-check the numbers to make sure it's still quadratic-ish
		-- as long as it's not perfectly linear, that's close enough


--TODO LATER: do more work on jump height and spring height
	--TODO: maybe change the sine curve to go from 25%-75% instead of 0%-100%

--TODO LATER: what was playercharacter's drawable parented to before we fixed SetParent in ArrangeFrame? (see "next" in Drawable_Runner35.lua)
	
--TODO: to avoid accounting for gradual speedup on every frame, apply speedups only at vertices
--TODO: insta-accelerate at vertex when max speed increases from gradual speedup,
	-- provided player is already moving at max speed.

do
	--local super=TRAININGGROUNDS_Mobile
	
	-- as long as we inherit GameObject instead of Mobile, we shouldn't have to worry too much about future-proofing
	
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_SECRET35_GameObject_Runner35 = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SECRET35_GameObject_Runner35
	
	function class:Setup(environment,scenario)
		super.Setup(self,environment)
		self.scenario=scenario
		self.alpha=1
		
		self.turning=false
		self.turnqueued=false
		self.turndirection=0
		self.remainingturnangle=0
		
		self.currentmovespeed=0
		
		
		self.intro=true		
		-- we wait an arbitrary number of frames after the scenario loads
		-- so as not to burn a lot of intro time on a "loading" frame
		-- TODO LATER: even just 1 frame is probably enough
		self.intrograceframesremaining=5
		-- (currenttime starts at 0, so introendtime will be a few seconds after 0)
		self.introendtime=3.5
		--self.introendtime=30.0	--!!!
		
		self.goalout=false
		-- wincondition 0: normal
		--				1: clearing board
		--				2: waiting on emerald
		self.wincondition=0
		
		self.speedmultiplier=0	
		--self.START_SPEED_MULTIPLIER=0.5
		self.START_SPEED_MULTIPLIER=1
		--self.START_SPEED_MULTIPLIER=2 --!!!
		self.MAX_SPEED_MULTIPLIER=2
		-- time between START_SPEED and MAX_SPEED
		self.PASSIVE_SPEEDUP_RATE=60.0*2.5
		-- time before game starts speeding up
		self.PASSIVE_SPEEDUP_GRACE_PERIOD=30.0
		
		-- this affects all player movement everywhere and should be set to 1 when not debugging
		self.DEBUG_TIME_MULTIPLIER=1
		--self.DEBUG_TIME_MULTIPLIER=0.5	--!!!
		


		
		-- make sure that longrange interactions clear themselves somehow after the first interaction
		-- otherwise, the player will loop forever in the longrange interaction state
		self.ignore_longrange_bumpers=false
		self.ILBx=nil
		self.ILBy=nil
		self.ILBrange=0
		--TODO: wears off whenever the player interacts with ANYTHING, including the same vertex,
		-- or comes to a stop after pressing forward after hitting a bumper.
		self.ignore_same_vertex=false
		self.ISVx=nil
		self.ISVy=nil
		-- after hitting a bumper, player must pass through a different vertex before they can input forward
		self.bumperforwardwillfail=false
		self.BFWFx=nil
		self.BFWFy=nil
		
		
		-- we've built in "one frame" of leeway for jumping.
		-- (this is intended to benefit framerates higher than 60fps, rather than lower)
		self.jumpinputtime=nil
		self.jumpinputduration=1.0/60		
		-- in addition to the 1/60sec leeway, we also allow 1 *actual* frame leeway, regardless of framerate.
		-- (this is intended to benefit lower framerates)
		--  -- remember to decrement remainingframes only once per frame, not per subframe!
		self.jumpinputremainingframes=0
		self.jumpqueued=false
		-- after touching the ground, player must wait "one frame" before jumping again
		-- player CAN queue up another jump during this time;
		-- it's not meant to make chain jumping more difficult, but it does force the player to run forward a bit between jumps.
		self.jumpcooldownendtime=nil
		--self.defaultjumpcooldown=1.0/60
		-- in the original game, due to frame-based movement, 
		-- the character is forced to move at least one subtile between jumps.
		-- we simulate this by enforcing a cooldown between jumps (and coming out of turns).
		-- jumpcooldown is divided by speedmultiplier.
		--self.defaultjumpcooldown=2.0/60
		self.defaultjumpcooldown=3.0/60
		-- default jump distance is exactly 2 tiles
		-- default jump time is 32.0/60 seconds (divided by speedmultiplier)
		-- we also use start/end jump time to determine player's height in midjump
		self.startjumptime=nil
		self.endjumptime=nil
		-- when player hits ground, they will land here unless bumper forward shenanigans occurred
		self.projectedjumpendx=nil
		self.projectedjumpendy=nil
		
		
		self.skidstopendtime=nil
		self.defaultskidstopduration=2.0/60		
		self.currenttime=0
		
		
		self.bumpered=false	
		self.springed=false
		
		--TODO: set to false upon minigame startup
		self.accelerating=true
		-- the direction in which we *should* be accelerating, if we are indeed accelerating
			-- (usually 1, this is 0 when starting the game, or -1 after hitting a bumper)
		self.targetspeedsignum=0
		
		
				
		-- self.currentmovespeed=-3.75*2--!!!
		-- self.accelerating=true		--!!!
		
		
	end
	
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		
		--TODO: not used?
		self.current_sphere_x=0
		self.current_sphere_y=0
		
		--TODO: there is currently a long-standing bug where the x- and y-axes are "mirrored" in all sorts of inconvenient ways.
		--self.x=15
		--self.y=25
		self.x=3
		self.y=33-3
		-- Direction of movement, provided currentmovespeed>0.
		-- (If currentmovespeed<0, player will move in the opposite direction.)
		self.xdirection=0
		self.ydirection=-1
		-- self.xdirection=1
		-- self.ydirection=0		
	
		-- grid_facing is the player's actual orientation on the grid,
		-- used to determine where the camera is pointing.
		-- 0 is facing positive x.
		-- math.pi/2 is facing positive y.
		-- (Camera will subtract math.pi/2 from this because the grid expects "0" to be facing positive y.)
		--TODO: why is grid_facing==0 negative x?
		--self.grid_facing=0
		self.grid_facing=math.atan2(self.ydirection,-self.xdirection)
		
		
		--TODO: calculate grid_facing from xdir+ydir, or vice versa
		
		-- currentfacing is used by ONLY BY DRAWABLE to face the player away from the screen.
		-- Will always be facing up, unless we try something silly when the player hits a GOAL sphere.
		-- (for the player's position on grid, grid_facing is a couple lines above us.)
		self.currentfacing=math.pi/2
		
		self.speedmultiplier=0
		
		-- actual time spent alive, ignoring speedmultipliers
		self.realalivetime=0
		
		-- used to determine background position
		-- (we can't use player's position as the background always scrolls "up" regardless of which way player is moving)
		self.backgroundmovement=0
		
		--self.y=0.5
		--self.y=0.85			-- the point at which sphere #8 is offscren enough that texture doesn't matter
								-- (you can still see the black outline border)
		--self.y=20000	
								
								
		--self.speedmultiplier=3.75*0.1	-- debug only		
		--self.speedmultiplier=3.75*1	--standard
		--self.speedmultiplier=3.75*2	--full speed
		--self.speedmultiplier=3.75*4		--full speed + spring		
		
		self.standardmovespeed=3.75*1
		--self.standardmovespeed=3.75*10	--!!!
		--self.accelerationrate=3.75/(8.0/60)		
		--TODO: when minigame starts, player instantly accelerates to top speed
		
		-- ACCELERATION RATE refers to acceleration after hitting forward after spring,
		-- not total rate of passive speedup.
		--Acceleration rate should be exactly 3.75 / 8 frames, but we've found we don't skid to a stop fast enough at very high speedmultiplier.
		-- (specifically, it's possible to cross an extra vertex which doesn't happen in the original game).
		-- so it is very slightly higher than it should be.
		-- as a point of trivia, it also turns out that -3.75/2 speed from initial position is just enough that we land exactly on the vertex
		-- and our remaining speed is low enough (in the neighborhood of 1E-17) that it rounds to zero!
		--self.accelerationrate=3.76/(8.0/60)
		self.accelerationrate=3.76/(8.0/60)
		--Springaccelerationrate is an undoctored 3.75*2, since any discrepancies will be less obvious.
		self.springaccelerationrate=3.75/(8.0/60)*2	

		
		self.turnspeed=(math.pi/2.0)/(16.0/60)
		self.goaloutturnspeed=(math.pi/2.0)/(8.0/60)
	

	end
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_SECRET35_Drawable_Runner35.new()
		self.drawable:Setup(self,self.environment)
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)

		-- xspeed/yspeed are deprecated; movement is handled in MovementModule
		self.xspeed=0
		self.yspeed=0
		--self.xspeed=self.xdirection*self.speedmultiplier
		--self.yspeed=self.ydirection*self.speedmultiplier		
	end	
	
	function class:Move(elapsed)		
	
		self.realalivetime=self.realalivetime+elapsed
	
		elapsed=elapsed*self.DEBUG_TIME_MULTIPLIER
	
		-- if we have reason to suspect the game is still loading, skip this frame
		if(self.intrograceframesremaining>0)then
			self.intrograceframesremaining=self.intrograceframesremaining-1
			return
		end
	
		--print("NEW FRAME-------------------------------------------------")
		--print("elapsed:",elapsed)
		if(self.jumpinputremainingframes)>0 then
			-- once per frame!  not once per subframe!
			self.jumpinputremainingframes=self.jumpinputremainingframes-1
		end		
		
		self.remainingmovetime=elapsed
		local antilockupmechanism=50
		while(self.remainingmovetime>0 and antilockupmechanism>0)do
			TRAININGGROUNDS_Secret35_MovementModule.SubMovement(self)
			antilockupmechanism=antilockupmechanism-1
		end
	end
	

	
	
	function class:GetNearestGridVertex()
		local gx,gy=self.scenario.grid:GridModulo(math.floor(self.x+0.5),math.floor(self.y+0.5))
		return gx,gy
	end
	
	--TODO: now that we're using this for bumpers only, hardcode range
	--TODO: can we get ILBx/ILBy from the sphere that called this function?
	function class:IgnoreLongrangeBumpers()		
		self.ignore_longrange_bumpers=true
		self.ILBx,self.ILBy=self:GetNearestGridVertex()
		self.ILBrange=1
		--print("IgnoreLongrangeBumpers was called",self.ILBx,self.ILBy)
	end
	
	function class:IsIgnoringThisLongrangeSphere(sphere)
		if(not sphere:IsABumper())then return false end
		if(self.ignore_longrange_bumpers)then
			local dist=self.scenario.grid:ModuloDistanceBetweenPoints(self.ILBx,self.ILBy,sphere.x,sphere.y)
			--print("Ignore sphere check:",dist,self.ILBrange)
			if(dist<=self.ILBrange)then return true end
		end
		return false
	end
	
	function class:IgnoreSameVertex()
		self.ignore_same_vertex=true
		self.ISVx,self.ISVy=self:GetNearestGridVertex()	
	end
	
	function class:IsIgnoringSameVertex(sphere)
		--print("ISV check:",sphere.x,sphere.y,"/",self.ISVx,self.ISVy)
		if(sphere:IsARing() and self:InteractsWithSpheres())then return false end
		if(not self.ignore_same_vertex)then return false end
		if(sphere.x~=self.ISVx)then return false end
		if(sphere.y~=self.ISVy)then return false end
		return true		
	end
		
	function class:GetCurrentAccelerationRate()
		local rate		
		if(self.springed)then
			rate=self.springaccelerationrate
		else
			rate=self.accelerationrate
		end
		rate=math.abs(rate)*self.targetspeedsignum
		return rate
	end
	
	-- function class:GetTerminalSpeed()
		-- local speed=self:GetMaxSpeed()*self.targetspeedsignum
		-- return speed
	-- end
	
	function class:GetMaxSpeed()
		local speed=self.standardmovespeed*self.speedmultiplier*self.targetspeedsignum
		if(self.springed)then speed=speed*2 end
		return speed
	end
	
	function class:AttemptQueueTurn(direction)
		if(self.turning)then return end
		self.turnqueued=true
		self.turndirection=direction		
	end
	
	function class:EndIntro()		
		if(self.intro)then
			self.intro=false
			self.introendtime=nil
			--TODO: maybe set speedmultiplier higher depending on time elapsed?
			self.speedmultiplier=self.START_SPEED_MULTIPLIER	
			self.accelerating=true		
			self.targetspeedsignum=1			
		end
	end
	
	function class:AttemptForward()
		--TODO: this does something slightly different at start of minigame
			-- (or, uh, does it...?)
		

		-- we have to check if player is already trying to move forward.
		-- if we don't have this check, there's technically nothing stopping player
		-- from trying to accelerate forward from max forward speed
		-- which, due to the way bumpers work,
		-- results in the player immediately turning around upon hitting a bumper.
		if(self.targetspeedsignum>0)then return end	
		if(self.turning)then return end
		if(self.bumperforwardwillfail)then return end
		
		--print("OK, forward...")
		
		--TODO LATER: quite a bit of overlap here...		
		if(self.intro)then
			self:EndIntro()
		end
		self.accelerating=true		
		self.targetspeedsignum=1
		
		
		--TODO: we implemented a fix to this recently, check that it actually works as intended
		-- if player is accelerating+moving forwards upon hitting a bumper, they have to accelerate BACKWARDS to NEGATIVE max speed.
			-- movementmodule is completely unequipped to handle this...
			-- if all else fails we can just cheat and set player to negative max speed instantly
				-- it's already kinda sorta an edge case, player would have to jump then turn around in midair in time to land within the bumper zone				
			-- TODO: we should probably also set player to forward max speed if they collide with one while moving backwards
				-- as it's rather likely the player will try this after all, when they get stuck in a line of bumpers
			-- TODO: if player is accelerating such that they hit a bumper behind them at the exact moment their speed goes from negative to positive,
				-- the bumper might bump them the wrong way depending on which order we process their speed in
					-- (also, it will be very difficult to check which way the player was "originally" headed
						-- as we process submovement in multiple steps)		
	end
	
	function class:IsJumpOnCooldown()
		if(not self.jumpcooldownendtime)then return false end
		return (self.jumpcooldownendtime>self.currenttime)
	end
	
	function class:JumpInput()
		--print("JumpInput")
		self.jumpinputtime=self.currenttime
		-- CheckPlayerInput (which calls this function) is called multiple times during the frame after the player presses jump.
		-- On the next frame, at start of step event, jumpinputremainingframes will be 1 and jump will attempt to queue again.
		-- on the frame after that, jumpinputremainingframes will be 0
		self.jumpinputremainingframes=2
	end
	
	function class:AttemptToQueueJump()
		--print("AttemptToQueueJump")
		if(self.endjumptime==nil)then
			--print("successfully")
			self.jumpqueued=true
		end
	end
	
	function class:AttemptQueuedJump()		
		if(self.endjumptime~=nil)then
			-- normally this shouldn't be possible -- we can only queue a jump if endjumptime is nil.
			-- however, if the player queues a jump and immediately hits a spring, the normal jump might still be queued		
				--TODO LATER: we recently set jumpqueued=false in Struct_Sphere as well.  do we need both?
			self.jumpqueued=false
			-- we should never see the following line, since we added the jumpqueue cancel to the sphere itself
			-- print("debug: canceled queued jump!")	--TODO LATER: assert failed?
		end
		--print("AttemptQueuedJump")			
		if(not self:IsJumpOnCooldown())then
			if(self.turning==false or self.goalout==true)then
				self:StartJump()
			end
		end
	end
	
	function class:EffectiveSpeedMultiplier()
		local effectivespeedmultiplier=self.speedmultiplier
		-- during intro, ignore 0 speedmultiplier and use starting speed instead
		if(effectivespeedmultiplier==0)then effectivespeedmultiplier=self.START_SPEED_MULTIPLIER end
		return effectivespeedmultiplier
	end
	
	function class:ResetToWinConditionSpeed()		
		-- called by wincondition==2
		
		self.speedmultiplier=self.START_SPEED_MULTIPLIER/2
		self.currentmovespeed=self:GetMaxSpeed()
		self:AttemptForward()
	end
	
	function class:StartJump()	
		--print("R35_StartJump")
		self.jumpqueued=false
		self.turnqueued=false
		local effectivespeedmultiplier=self:EffectiveSpeedMultiplier()		
		self.startjumptime=self.currenttime
		self.endjumptime=self.startjumptime+(32.0/60)/effectivespeedmultiplier
		if(self.goalout==false)then
			self.projectedjumpendx=self.x+2*TRAININGGROUNDS_signum(self.currentmovespeed)*self.xdirection
			self.projectedjumpendy=self.y+2*TRAININGGROUNDS_signum(self.currentmovespeed)*self.ydirection
		else
			self.projectedjumpendx=self.x
			self.projectedjumpendy=self.y
		end
		
		self.follower:QueueJump()
		
	end
	
	function class:EndJump()
		--print("EndJump")
		self.startjumptime=nil
		self.endjumptime=nil
		--this is called after distance/time advance functions
		-- so we don't have to worry about advancing twice in the same subframe
		if(self.projectedjumpendx)then
			self.x=self.projectedjumpendx
			self.y=self.projectedjumpendy
		end	
		-- reminder that we must take actions AFTER advancing distance/timer...
		local effectivespeedmultiplier=self:EffectiveSpeedMultiplier()		
		self.jumpcooldownendtime=self.currenttime+self.defaultjumpcooldown/effectivespeedmultiplier
		
		self.springed=false
		--if we were springed, clamp currentmovespeed back down to non-springed speeds
		if(math.abs(self.currentmovespeed)>math.abs(self:GetMaxSpeed()))then
			-- maxspeed takes targetspeedsignum into account
			-- but we just want to cap it to the direction we're CURRENTLY going,
			-- not the direction we might be accelerating to.
			self.currentmovespeed=math.abs(self:GetMaxSpeed())*TRAININGGROUNDS_signum(self.currentmovespeed)
			--TODO LATER: not sure if this accel check is necessary or if it would be naturally resolved on the next subframe
			if(TRAININGGROUNDS_signum(self.currentmovespeed)==self.targetspeedsignum)then
				self.accelerating=false
			end
		end
	end
	
	
	function class:DoneTurning()
		self.turning=false
		local oldx=self.xdirection
		self.xdirection=self.ydirection*self.turndirection
		self.ydirection=oldx*-self.turndirection
		-- normally, we always apply jumpcooldown after ending a turn.
		-- HOWEVER, during the intro, we have to ignore jumpcooldown,
		-- or else it becomes impossible to jump while holding turn (which was possible in the original)
		if(not self.intro)then
			local effectivespeedmultiplier=self:EffectiveSpeedMultiplier()		
			self.jumpcooldownendtime=self.currenttime+self.defaultjumpcooldown/effectivespeedmultiplier
		end
	end	
	
	function class:AtVertex(vx,vy)	
		--if player is <1 or >32, wrap them around now
		local grid=self.scenario.grid
		if(self.x<1)then self.x=self.x+grid.WORLD_WIDTH;vx=vx+grid.WORLD_WIDTH end
		if(self.y<1)then self.y=self.y+grid.WORLD_WIDTH;vy=vy+grid.WORLD_WIDTH end
		if(self.x>grid.WORLD_WIDTH)then self.x=self.x-grid.WORLD_WIDTH;vx=vx-grid.WORLD_WIDTH end
		if(self.y>grid.WORLD_WIDTH)then self.y=self.y-grid.WORLD_WIDTH;vy=vy-grid.WORLD_WIDTH end
		
		vx,vy=grid:GridModulo(vx,vy)
		
		-- clear bumperforward if the player is at any other vertex		
		if(self.bumperforwardwillfail)then
			local BFWFx,BFWFy=grid:GridModulo(self.BFWFx,self.BFWFy)		
			--print("BFWF check:",vx,vy,BFWFx,BFWFy)
			if(not(vx==BFWFx and vy==BFWFy))then
				--print("OK, clear BFWF")
				self.bumperforwardwillfail=false
			end
		end
	
		
		--unflag various other flags here.
		-- don't clear ignore_same_vertex as we haven't interacted with vertex yet!
		-- also, before clearing ILB, make sure we're not at the SAME bumper we just hit.
		-- (this can occur if the player jumps past the bumper, hits the other side, and walks backwards through vertex)
		local samebumper=false
		if(self.ignore_longrange_bumpers and self.ILBx==vx and self.ILBy==vy)then
			--print("samebumper; skip flag clear")
			samebumper=true
		end
		if(not samebumper)then
			--print("clear ILB; comparing",self.ILBx,self.ILBy,vx,vy)
			self.ignore_longrange_bumpers=false
			self.ILBx=nil
			self.ILBy=nil
		end
		
		-- if player is in midair, can't interact with anything on ground...
		if(self.endjumptime)then	
			return
		end
						
		--increase player's max speed (speedmultiplier) based on total time spent in scenario
		--if player was already moving at max speed, increase player's speed to the new maximum
		--TODO: not formally tested.  make sure this doesn't interfere with other movement code
		if(self.wincondition~=2)then
			local alreadymaxspeed=false
			if(self.currentmovespeed==self:GetMaxSpeed())then
				alreadymaxspeed=true
			end
			local amount=(self.realalivetime-self.PASSIVE_SPEEDUP_GRACE_PERIOD)/self.PASSIVE_SPEEDUP_RATE
			if(amount<0)then amount=0 end
			if(amount>1)then amount=1 end
			self.speedmultiplier=self.START_SPEED_MULTIPLIER+(self.MAX_SPEED_MULTIPLIER-self.START_SPEED_MULTIPLIER)*amount
			if(alreadymaxspeed)then
				self.currentmovespeed=self:GetMaxSpeed()
			end
		else			
			-- but once the emerald appears, reset to half speed
			self:ResetToWinConditionSpeed()			
		end
		
		
		--finally, interact with the sphere if it exists
		local sphere=grid:GetSphereAt(vx,vy)
		if(sphere)then
			self:InteractWithSphere(sphere)
			self.ignore_same_vertex=true
			self.ISVx=sphere.x
			self.ISVy=sphere.y	
		else		
			self.ignore_same_vertex=false
			self.ISVx=nil
			self.ISVy=nil
		end
		
		
		self:CheckTurnQueueAndStartTurning()
	end
	

	
	function class:CheckTurnQueueAndStartTurning()
		if(self.turnqueued)then
			self.turnqueued=false
			self.turning=true
			self.remainingturnangle=math.pi/2
		end		
	end
	
	function class:StartGoalout()
		self.goalout=true
		self.turnqueued=false
		self.turning=true
		self.turndirection=-1
		self.remainingturnangle=math.pi/2
		local whiteout=TRAININGGROUNDS_SECRET35_Whiteout.new()
		whiteout:Setup(self.environment)
	end
	
	function class:InteractAtLongDistance(sphere)
		-- this doesn't need to be a separate function
		-- except it's useful to print debug statements...
		--print("InteractAtLongDistance",sphere)
		self:InteractWithSphere(sphere)
	end
	
	function class:InteractWithSphere(sphere)
		--print("InteractWithSphere",sphere,self.ignore_same_vertex,self.ISVx,self.ISVy,sphere.x,sphere.y)
		--print("InteractWithSphere",sphere,self.x,self.y)
		--print("InteractWithSphere",sphere)
		
		
		--if(self.ignore_same_vertex and sphere.x==self.ISVx and sphere.y==self.ISVy)then 
		if(self:IsIgnoringSameVertex(sphere))then
			--print("but we ignored it...") 
			return 
		end		
		
		sphere:OnInteract(self)
	end
	
	function class:InteractsWithSpheres()
		if(self.wincondition==0 or self.wincondition==2)then return true
		else return false
		end
	end
	
	
	function class:PreDraw(elapsed)
		local alpha=1.0
	
		if(self.endjumptime)then
			local t=(self.endjumptime-self.currenttime)/(self.endjumptime-self.startjumptime)*math.pi
			local heightmultiplier=math.sin(t)
			if(self.springed)then
				heightmultiplier=heightmultiplier*2.25
			end
			local effectivespeedmultiplier=self:EffectiveSpeedMultiplier()		
			local divisor=effectivespeedmultiplier
			-- for reasons unknown (TODO LATER) our high jumps are too high and our low jumps are too low
			-- so as we speed up, diminishing returns kick in.
			if(divisor>1)then
				--log(1) equals zero, so
				divisor=1+math.log(divisor)				
				-- at 2 speed, this gives us a divisor of about 1.6
			end
			--self.z=heightmultiplier*4.5/divisor
			self.z=heightmultiplier*4/effectivespeedmultiplier
		else
			self.z=0
		end
					
	
		--animation picking was moved to RunnerAnimationSystem
	


		TRAININGGROUNDS_GameObject.PreDraw(self,elapsed)
	end
	

end