do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_SECRET35_HUDLeft = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SECRET35_HUDLeft
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.total=0
	end
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_SECRET35_HUDLeft_Drawable.new()
		self.drawable:Setup(self,self.environment)
	end
	
	function class:CountSpheres(grid)
		local total=0
		for x=1,grid.WORLD_WIDTH do
			for y=1,grid.WORLD_WIDTH do
				local sphere=grid:GetSphereAt(x,y)
				if(sphere:IsAGetSphere())then
					total=total+1					
				end
			end
		end		
		--print("Total:",total)
		self:SetDisplay(total)
		self.total=total
		return total
	end
	
	function class:IncrementRings()
		self.total=self.total+1
		self:SetDisplay(self.total)
		return self.total
	end
	
	function class:SetDisplay(total)
		local hundred=math.floor(total/100)
		local ten=math.floor((total%100)/10)
		local one=total%10
		--print(hundred,ten,one)
		self.drawable.hundredsdigit.texture:SetTexCoord(hundred/16,0/16,hundred/16,1/16,(hundred+1)/16,0/16,(hundred+1)/16,1/16)
		self.drawable.tensdigit.texture:SetTexCoord(ten/16,0/16,ten/16,1/16,(ten+1)/16,0/16,(ten+1)/16,1/16)
		self.drawable.onesdigit.texture:SetTexCoord(one/16,0/16,one/16,1/16,(one+1)/16,0/16,(one+1)/16,1/16)	
	end
	 
end

do
	local super=TRAININGGROUNDS_Drawable
	TRAININGGROUNDS_SECRET35_HUDLeft_Drawable = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SECRET35_HUDLeft_Drawable

	function class:CreateFrame()
		self.frames={}
		self.frame=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.frame:Show()
		tinsert(self.frames,self.frame)
		self.left=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.left:Show()
		tinsert(self.frames,self.left)
		self.right=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.right:Show()
		tinsert(self.frames,self.right)
		self.top=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.top:Show()
		tinsert(self.frames,self.top)
		self.bottom=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.bottom:Show()
		tinsert(self.frames,self.bottom)
		self.graphic=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.graphic:Show()
		tinsert(self.frames,self.graphic)
		self.hundredsdigit=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.hundredsdigit:Show()
		tinsert(self.frames,self.hundredsdigit)
		self.tensdigit=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.tensdigit:Show()
		tinsert(self.frames,self.tensdigit)
		self.onesdigit=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.onesdigit:Show()
		tinsert(self.frames,self.onesdigit)
		
	end
	local WIDTH,HEIGHT=200,50
	function class:SetFrameAppearance()			
		self.frame:SetSize(WIDTH,HEIGHT)
		self.left:SetParent(self.frame)
		self.left:SetSize(2,HEIGHT+4)
		self.left:SetPoint("TOPLEFT",self.frame,"TOPLEFT",-2,2)
		self.left.texture:SetColorTexture(1,1,1,1)
		self.left.texture:Show()
		self.left:SetAlpha(1)
		self.right:SetParent(self.frame)
		self.right:SetSize(HEIGHT+4,HEIGHT+4)
		self.right:SetPoint("TOPRIGHT",self.frame,"TOPRIGHT",2,2)
		self.right.texture:SetColorTexture(1,1,1,1)
		self.right.texture:Show()
		self.right:SetAlpha(1)		
		self.graphic:SetParent(self.right)
		self.graphic:SetPoint("CENTER",self.right)
		self.graphic:SetSize(45,45)
		self.graphic.texture:SetTexture("Interface\\AddOns\\TrainingGrounds_GetSpheres\\Assets\\Graphics\\rendertest_colors.tga")
		if(not self.owner.environment.game.scenario.inversemode)then
			self.graphic.texture:SetTexCoord(0,6/8,0,7/8,1/8,6/8,1/8,7/8)						
		else
			self.graphic.texture:SetTexCoord(0,2/8,0,3/8,1/8,2/8,1/8,3/8)	
		end
		self.graphic.texture:Show()
		local DIFF=40
		local OFFSET=-27
		self.hundredsdigit:SetAlpha(1)			
		self.hundredsdigit:SetParent(self.frame)
		self.hundredsdigit:SetPoint("CENTER",self.frame,"CENTER",-DIFF+OFFSET,0)
		self.hundredsdigit:SetSize(55,55)
		self.hundredsdigit.texture:SetTexture("Interface\\AddOns\\TrainingGrounds_GetSpheres\\Assets\\Graphics\\HUD.tga")
		self.hundredsdigit.texture:SetTexCoord(0,0/16,0,1/16,1/16,0/16,1/16,1/16)
		self.hundredsdigit.texture:Show()
		self.hundredsdigit:SetAlpha(1)	
		self.tensdigit:SetParent(self.frame)
		self.tensdigit:SetPoint("CENTER",self.frame,"CENTER",0+OFFSET,0)
		self.tensdigit:SetSize(55,55)
		self.tensdigit.texture:SetTexture("Interface\\AddOns\\TrainingGrounds_GetSpheres\\Assets\\Graphics\\HUD.tga")
		self.tensdigit.texture:SetTexCoord(0,0/16,0,1/16,1/16,0/16,1/16,1/16)
		self.tensdigit.texture:Show()
		self.tensdigit:SetAlpha(1)	
		self.onesdigit:SetParent(self.frame)
		self.onesdigit:SetPoint("CENTER",self.frame,"CENTER",DIFF+OFFSET,0)
		self.onesdigit:SetSize(55,55)
		self.onesdigit.texture:SetTexture("Interface\\AddOns\\TrainingGrounds_GetSpheres\\Assets\\Graphics\\HUD.tga")
		self.onesdigit.texture:SetTexCoord(0,0/16,0,1/16,1/16,0/16,1/16,1/16)
		self.onesdigit.texture:Show()
		self.onesdigit:SetAlpha(1)			
		self.top:SetParent(self.frame)
		self.top:SetSize(WIDTH+2,2)
		self.top:SetPoint("TOPLEFT",self.frame,"TOPLEFT",-2,2)
		self.top.texture:SetColorTexture(1,1,1,1)
		self.top.texture:Show()
		self.top:SetAlpha(1)
		self.bottom:SetParent(self.frame)
		self.bottom:SetSize(WIDTH+2,2)
		self.bottom:SetPoint("BOTTOMLEFT",self.frame,"BOTTOMLEFT",-2,-2)
		self.bottom.texture:SetColorTexture(1,1,1,1)
		self.bottom.texture:Show()
		self.bottom:SetAlpha(1)		
	end		
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.shadowframelayer
	end		
	function class:ArrangeFrame(parentanchor,cposx,cposy,cposz,cangx,cangy,cangz)
		self.frame:ClearAllPoints()		
		self.frame:SetParent(self.parentframe)
		local x=-self.parentframe:GetWidth()/2+WIDTH/2+60
		local y=self.parentframe:GetHeight()/2-HEIGHT/2-60
		self.frame:SetPoint(self.anchor,self.parentframe,parentanchor,x,y)		
		self:SetFrameSizeAndOrientation(WIDTH,HEIGHT,yaw,-math.pi/2+0.75,1)
		
		self.right:SetFrameLevel(100)
		self.graphic:SetFrameLevel(101)
	end	
	
end






do
	local super=TRAININGGROUNDS_SECRET35_HUDLeft
	TRAININGGROUNDS_SECRET35_HUDRight = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SECRET35_HUDRight
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_SECRET35_HUDRight_Drawable.new()
		self.drawable:Setup(self,self.environment)
	end
	
	
end

do
	local super=TRAININGGROUNDS_Drawable
	TRAININGGROUNDS_SECRET35_HUDRight_Drawable = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SECRET35_HUDRight_Drawable

	function class:CreateFrame()
		self.frames={}
		self.frame=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.frame:Show()
		tinsert(self.frames,self.frame)
		self.left=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.left:Show()
		tinsert(self.frames,self.left)
		self.right=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.right:Show()
		tinsert(self.frames,self.right)
		self.hundredsdigit=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.hundredsdigit:Show()
		tinsert(self.frames,self.hundredsdigit)
		self.tensdigit=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.tensdigit:Show()
		tinsert(self.frames,self.tensdigit)
		self.onesdigit=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.onesdigit:Show()
		tinsert(self.frames,self.onesdigit)		
		self.top=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.top:Show()
		tinsert(self.frames,self.top)
		self.bottom=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.bottom:Show()
		tinsert(self.frames,self.bottom)
		self.graphic=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.graphic:Show()
		tinsert(self.frames,self.graphic)
	end
	local WIDTH,HEIGHT=200,50
	function class:SetFrameAppearance()			
		self.frame:SetSize(WIDTH,HEIGHT)
		self.left:SetParent(self.frame)
		self.left:SetSize(HEIGHT+4,HEIGHT+4)
		self.left:SetPoint("TOPLEFT",self.frame,"TOPLEFT",-2,2)
		self.left.texture:SetColorTexture(1,1,1,1)
		self.left.texture:Show()
		self.left:SetAlpha(1)
		self.right:SetParent(self.frame)
		self.right:SetSize(2,HEIGHT+4)
		self.right:SetPoint("TOPRIGHT",self.frame,"TOPRIGHT",2,2)
		self.right.texture:SetColorTexture(1,1,1,1)
		self.right.texture:Show()
		self.right:SetAlpha(1)		
		self.graphic:SetParent(self.left)
		self.graphic:SetPoint("CENTER",self.left)
		self.graphic:SetSize(45,45)
		self.graphic.texture:SetTexture("Interface\\AddOns\\TrainingGrounds_GetSpheres\\Assets\\Graphics\\rendertest_rings.tga")		
		local x=4/8;local y=3/8
		--local x=6/8;local y=3/8
		self.graphic.texture:SetTexCoord(x,y,x,y+1/8,x+1/8,y,x+1/8,y+1/8)	
		self.graphic.texture:Show()
		self.graphic:SetAlpha(1)			
		local DIFF=40
		local OFFSET=27
		self.hundredsdigit:SetAlpha(1)			
		self.hundredsdigit:SetParent(self.frame)
		self.hundredsdigit:SetPoint("CENTER",self.frame,"CENTER",-DIFF+OFFSET,0)
		self.hundredsdigit:SetSize(55,55)
		self.hundredsdigit.texture:SetTexture("Interface\\AddOns\\TrainingGrounds_GetSpheres\\Assets\\Graphics\\HUD.tga")
		self.hundredsdigit.texture:SetTexCoord(0,0/16,0,1/16,1/16,0/16,1/16,1/16)
		self.hundredsdigit.texture:Show()
		self.hundredsdigit:SetAlpha(1)	
		self.tensdigit:SetParent(self.frame)
		self.tensdigit:SetPoint("CENTER",self.frame,"CENTER",0+OFFSET,0)
		self.tensdigit:SetSize(55,55)
		self.tensdigit.texture:SetTexture("Interface\\AddOns\\TrainingGrounds_GetSpheres\\Assets\\Graphics\\HUD.tga")
		self.tensdigit.texture:SetTexCoord(0,0/16,0,1/16,1/16,0/16,1/16,1/16)
		self.tensdigit.texture:Show()
		self.tensdigit:SetAlpha(1)	
		self.onesdigit:SetParent(self.frame)
		self.onesdigit:SetPoint("CENTER",self.frame,"CENTER",DIFF+OFFSET,0)
		self.onesdigit:SetSize(55,55)
		self.onesdigit.texture:SetTexture("Interface\\AddOns\\TrainingGrounds_GetSpheres\\Assets\\Graphics\\HUD.tga")
		self.onesdigit.texture:SetTexCoord(0,0/16,0,1/16,1/16,0/16,1/16,1/16)
		self.onesdigit.texture:Show()
		self.onesdigit:SetAlpha(1)					
		self.top:SetParent(self.frame)
		self.top:SetSize(WIDTH+2,2)
		self.top:SetPoint("TOPLEFT",self.frame,"TOPLEFT",-2,2)
		self.top.texture:SetColorTexture(1,1,1,1)
		self.top.texture:Show()
		self.top:SetAlpha(1)
		self.bottom:SetParent(self.frame)
		self.bottom:SetSize(WIDTH+2,2)
		self.bottom:SetPoint("BOTTOMLEFT",self.frame,"BOTTOMLEFT",-2,-2)
		self.bottom.texture:SetColorTexture(1,1,1,1)
		self.bottom.texture:Show()
		self.bottom:SetAlpha(1)		
	end		
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.shadowframelayer
	end		
	function class:ArrangeFrame(parentanchor,cposx,cposy,cposz,cangx,cangy,cangz)
		self.frame:ClearAllPoints()		
		self.frame:SetParent(self.parentframe)
		local x=self.parentframe:GetWidth()/2-WIDTH/2-60,0
		local y=self.parentframe:GetHeight()/2-HEIGHT/2-60,0
		self.frame:SetPoint(self.anchor,self.parentframe,parentanchor,x,y)		
		self:SetFrameSizeAndOrientation(WIDTH,HEIGHT,yaw,-math.pi/2+0.75,1)
		
		self.left:SetFrameLevel(100)
		self.graphic:SetFrameLevel(101)		
	end	
	
end