--TODO: y'know technically we could just say class=..._GameObject_Runner35 
	-- and write all this as a direct continuation of that file and nothing would break
	
--TODO: skidstop+already_in_range hasn't been formally tested

--TODO: some checks we're currently comparing player.something_happens_time to player.currenttime
	-- rather than player.something_happens_time~=nil.
	-- for those cases, if two things occur at the same time, the second will be ignored forever because its time<0
	-- we need to switch those to compare-to-nil checks
	
--TODO: a whole bunch of facing-towards-negative-x/y movement undoubtedly broke because we forgot to use signum
	
	
--TODO LATER:
-- currently, player doesn't interact with 0,0 vertex on game start.  that should be okay, but maybe keep it in mind if something breaks...

-- TODO: check whether any of this integral calculus stuff is actually implemented correctly.
--		we're not holding our breath.

--REMINDER: if we see interactions with the same bumper sphere, LONG_DISTANCE followed by VERTEX (ignored),
-- it's because we overshot the bumper and passed through it backwards.
-- TODO NEXT: ...and that's probably what's setting ignore_longrange=false too early.

--[[
	when turning:
		only need to check endframetime vs finished-turning.
		probably the easiest.
		compare times only.
	
	when in midair:
		need to check endframetime, land-on-ground, and bumper-forward.
		compare times only.
		
	when on ground:
		step zero: check if we're in range of next-interaction-point.	
		first, check bumper-forward.  save both time and distance.
			* "bumper-forward" is the point where velocity becomes positive, OR the point where we hit top speed
		check distance of next-interaction-point, queued-jump, and next-vertex.  save distance and time.
			if bumper-forward exists:			
				compare DISTANCE with bumper-forward.  
					if distance is closer, discard bumper-forward and save nearest point's TIME.
					otherwise, save bumper-forward time
			if bumper-forward does not exist:
				calc lowest TIME to point
		...compare the lowest saved time to endframetime
		
	now fast-forward to the saved time (i.e. move player the appropriate distance)
	and take the appropriate action for the location
		
		
	

]]--


do
	TRAININGGROUNDS_Secret35_MovementModule={}
	local move=TRAININGGROUNDS_Secret35_MovementModule
	
	-- Local function pre-declarations:
	--local CanPlayerCoverDistanceWhileSkidding 
	local GetTimeToCoverDistanceGivenConstantAccel
	--local ReachedAccelBreakpoint
	local ReachedAccelBreakpoint_Zero_Pause
	local ReachedAccelBreakpoint_Max
	local PlayerAtVertex
	local GetDistanceToSphereAndInteractDistance
	
	local function DebugPrintDTA(state,dta)
		if(false)then
			if(dta.debug and dta.debug~="REMAINING")then
			--if(dta.debug)then
				print("Debug:",state,"state >",dta.debug,dta.time,dta.distance)
			end
		end
	end
	
	
	local function AddMoveTarget(movetarget)
		if(movetarget)then
			move.movetargets:tinsert(movetarget)
		end
	end

	--function expects a series of tables with a .time property (intended for use with DTA)
	local function GetMinimumNotNilTime(...)
		local minimum=nil
		local arg={...}
		for i=1,#arg do
			if(arg[i])then
				if((not minimum) or arg[i].time<minimum.time)then
					minimum=arg[i]
				end
			end
		end
		return minimum
	end

	
	local function AlreadyInRangeOfNextInteractionPoint(player)
		--returns nil if nothing in range, otherwise returns the sphere in range.
		--TODO: rename function
		
		local dist,interactdistance,sphere=GetDistanceToSphereAndInteractDistance(player)		
		if(not (dist and interactdistance and sphere))then return end
		
		
--print("AIR",gx,gy,dist,interactdistance,sphere)	
		
		if(dist<=interactdistance)then
			return sphere
		end
		return nil
	end
	
	local function GetNextGridVertex(player)
		if(player.currentmovespeed==0)then
			return nil,nil
		end
		local grid=player.scenario.grid
		---- don't do this.  we are leaving this here as a reminder not to do this.
		---- this rounds towards nearest vertex, then adds 1.
		---- this will fail spectacularly when the player is <0.5 away from the next vertex.
		-- local currentx,currenty=player:GetNearestGridVertex()
		-- local nextx=currentx+player.xdirection*TRAININGGROUNDS_signum(player.currentmovespeed)
		-- local nexty=currenty+player.ydirection*TRAININGGROUNDS_signum(player.currentmovespeed)
		-----------------------------------------------------------------------------------------
		---- instead, add 0.5*direction to the player's current (unrounded) position
		---- and THEN round towards nearest vertex.
		local currentxplus=player.x+0.5*player.xdirection*TRAININGGROUNDS_signum(player.currentmovespeed)
		local currentyplus=player.y+0.5*player.ydirection*TRAININGGROUNDS_signum(player.currentmovespeed)		
		local nextx=math.floor(currentxplus+0.5)
		local nexty=math.floor(currentyplus+0.5)
		-- that should work... unless the player is EXACTLY on a vertex and moving backwards, 
		-- in which case it will subtract 0.5, add 0.5, and land on the same vert as we started
			-- (to fix that, we apply the +1 thing we warned not to do above.)
		if(nextx==player.x and nexty==player.y)then
			nextx=nextx+player.xdirection*TRAININGGROUNDS_signum(player.currentmovespeed)
			nexty=nexty+player.ydirection*TRAININGGROUNDS_signum(player.currentmovespeed)			
		end
		
		return nextx,nexty		
	end
	

	
	function GetDistanceToSphereAndInteractDistance(player)
		-- round position to nearest vertex
		local gx,gy=player:GetNearestGridVertex()
		local px,py=player.scenario.grid:GridModulo(player.x,player.y)
		local sphere=player.scenario.grid:GetSphereAt(gx,gy)
		
		if(not sphere)then return nil,nil,nil end

		if(player:IsIgnoringSameVertex(sphere))then
			return nil,nil,nil
		end
		
		if(player:IsIgnoringThisLongrangeSphere(sphere))then
			return nil,nil,nil
		end			
			
		local interactdistance=sphere.interact_distance
		if(not interactdistance)then
			return nil,nil,nil
		end
		
		local dist=player.scenario.grid:ModuloDistanceBetweenPoints(player.x,player.y,gx,gy)
		
		-- local distx=math.abs(player.x-gx)
		-- local disty=math.abs(player.y-gy)
		-- distx=distx%player.scenario.grid.WORLD_WIDTH
		-- disty=disty%player.scenario.grid.WORLD_WIDTH
		-- if(distx>16)then distx=distx-32 end
		-- if(disty>16)then disty=disty-32 end		
		-- local dist=math.max(distx,disty)


		
		return dist,interactdistance,sphere
	end
	
	
	
		
	local function CalcAccelBreakpoint(player)
		-- Distance/time at which, due to acceleration, player's movespeed changes to -max_speed, 0, or max_speed.
		-- Primarily used to determine the total distance a player will cover before skidding to a halt after a bumper.
		if(not player.accelerating)then return nil end
		local init_speed=player.currentmovespeed		
		local target_speed
		local accel_rate=player:GetCurrentAccelerationRate()
		local breakpointfunction

		if(init_speed~=0 and TRAININGGROUNDS_signum(init_speed)~=player.targetspeedsignum)then 
			target_speed=0 
			if(player.targetspeedsignum>0)then
				-- only skid to a stop if player was moving backwards and is now moving fowards.
				breakpointfunction=ReachedAccelBreakpoint_Zero_Pause
			else
				-- if player was moving forwards and is now moving backwards,
				-- ...well, we should never reach this point in the first place
				-- the only time the player should be accelerating backwards 
				-- is after hitting a bumper while accelerating forwards
				-- at which point the player should instantaneously begin moving backwards,
				-- preventing them from accelerating "through" zero...
				breakpointfunction=ReachedAccelBreakpoint_Max
			end
		else 
			target_speed=player:GetMaxSpeed() 
			breakpointfunction=ReachedAccelBreakpoint_Max
		end
		
		local accel_time
		-- New to 8.2.5 PTR: warcraft complains if you divide by zero.  so we use this workaround instead
		if(accel_rate~=0)then
			accel_time=(target_speed-init_speed)/accel_rate
		else
			accel_time=tonumber("inf")*TRAININGGROUNDS_signum(target_speed-init_speed)
		end
		local accel_distance=(init_speed+target_speed)/2*accel_time
		return {distance=accel_distance,time=accel_time,action=function()breakpointfunction(player)end,debug="ACCEL_BREAK"}
	end
	
	local function CalcAccelBreakpointMaxSpeedOnly(player)
		-- Distance/time at which, due to acceleration, player's movespeed changes to max_speed.
		-- Primarily used when determining total distance traveled in a given timestep.
		-- (note, however:
		-- 	1. the player will always pause a moment upon accelerating from negative to positive speed
		--			so this number will be inaccurate in those situations
		--  2. we only use this for total-distance-with-nothing-in-between
		-- 			so the player will "hit" CalcAccelBreakpoint first in the above situation
		-- 			so it doesn't really matter that it's inaccurate
		if(not player.accelerating)then return nil end
		local init_speed=player.currentmovespeed
		local target_speed=player:GetMaxSpeed()
		local accel_rate=player:GetCurrentAccelerationRate()
		local accel_time
		-- New to 8.2.5 PTR: warcraft complains if you divide by zero.  so we use this workaround instead
		if(accel_rate~=0)then
			accel_time=(target_speed-init_speed)/accel_rate
		else
			accel_time=tonumber("inf")*TRAININGGROUNDS_signum(target_speed-init_speed)
		end
		local accel_distance=(init_speed+target_speed)/2*accel_time
		return {distance=accel_distance,time=accel_time,action=function()ReachedAccelBreakpoint(player)end,debug="ACCEL_BREAK_MAX"}
	end	

	--TODO: should these go in Player?
	function ReachedAccelBreakpoint_Zero_Pause(player)
		player.currentmovespeed=0
		player.ignoresamevertex=false
		
		player.accelerating=false		
		player.skidstopendtime=player.currenttime+player.defaultskidstopduration
	end
	
	function ReachedAccelBreakpoint_Max(player)
		player.accelerating=false
		player.currentmovespeed=player:GetMaxSpeed()
	end
	
	
	function SkidStopDone(player)
		player.skidstopendtime=nil
		player.accelerating=true
		player.bumpered=false
	end
	
	
	
	local function GetTimeBetweenPlayerAndDistance(player,distance)		
		if(distance==0)then return 0 end

		if(not player.accelerating)then				
			-- constant speed is easy
			return distance/player.currentmovespeed				
		else
			-- non-constant speed is not so easy		
			--if player won't reach this point because they're skidding to a stop after hitting a bumper,
			-- function will return nil.			
			--if(CanPlayerCoverDistanceWhileSkidding(player,distance)==false) then
--				return nil	
			-- --if player is skidding to a stop (moving backwards), but will still cover the distance,
			-- -- calculate the full distance in one go
			-- elseif(player.currentmovespeed<0)then
				-- local movetime=GetTimeToCoverDistanceGivenConstantAccel(player,distance)
				-- return movetime				
			-- else
			-- --if player is accelerating while moving forward, we split the distance into covered-while-accelerating
			-- -- and covered-while-constant-speed.
				-- local DTA=CalcAccelBreakpoint(player)
				-- local acceldist=DTA.distance
				-- local nonacceldist=distance-acceldist
				-- local playermaxspeed=player:GetMaxSpeed()
				-- local accelmovetime=GetTimeToCoverDistanceGivenConstantAccel(player,distance)
				-- local nonaccelmovetime=nonacceldist/playermaxspeed
				-- return accelmovetime+nonaccelmovetime			
			-- end

			--if player won't cover the full distance because they're skidding to a stop after hitting a bumper,
			-- function will return nil.	
			-- if player movespeed<0 and player is accelerating, we need to know how far until accel breakpoint.
			-- (calculate accel breakpoint regardless, we'll need this later)
			-- (remember that DTA is nil if player is not accelerating, so we don't need to check player.accelerating)
			local DTA=CalcAccelBreakpoint(player)
				-- this is slightly redundant for the sake of readability -- if DTA, then player.accelerating==true
			if(player.currentmovespeed<0 and player.accelerating and DTA)then
				if(math.abs(DTA.distance)<math.abs(distance))then 
					return nil
				end
			end
			-- if we're here, then player will cover the full distance
			-- for our own sanity, split the distance into 
			-- distance-covered-while-accelerating and distance-covered-at-const-speed
			local acceldist,nonacceldist
			if(math.abs(DTA.distance)>=distance)then
				acceldist=distance
				nonacceldist=0
			else
				--TODO LATER: does this matter?  we're ultimately going to discard this result and use DTA_accelbreakpoint instead
				acceldist=DTA.distance
				nonacceldist=distance-acceldist
			end
			--TODO LATER: if acceldist=DTA.distance, then we already know accelmovetime=DTA.time
			local accelmovetime=GetTimeToCoverDistanceGivenConstantAccel(player,acceldist)
			local playermaxspeed=player:GetMaxSpeed()
			local nonaccelmovetime=nonacceldist/playermaxspeed
			return accelmovetime+nonaccelmovetime
			
			-- else
				-- --if player 
			-- end
		end
	end
	
	
	local function GetPlayerDistanceCoveredDuringTime(player,movetime)
		-- where "movetime" is expected to be, but not necessarily, the player's entire remainingmovetime
		if(not player.accelerating)then
			return player.currentmovespeed*movetime
		else
	--TODO: rename CalcAccelBreakpoint series to reflect they return a DTA
			-- split time between time spent accelerating and time traveling at const speed
			-- (if player is accelerating from negative to positive, this answer will be wrong
			--  but the number will be discarded in favor of CalcAccelBreakpoint instead.)
			local DTA=CalcAccelBreakpointMaxSpeedOnly(player)
			local acceltime
			local acceldist			
			if(movetime<=DTA.time)then
				acceltime=movetime
				local init_speed=player.currentmovespeed
				local final_speed=init_speed+player:GetCurrentAccelerationRate()*acceltime
				acceldist=(init_speed+final_speed)/2*acceltime
				--print("GPDCDT speeds/time:",init_speed,final_speed,movetime)
			else
				acceltime=DTA.time
				acceldist=DTA.distance
			end
			local nonacceltime=movetime-acceltime
			local nonacceldist=nonacceltime*player:GetMaxSpeed()
			--print("GetPlayerDistanceCoveredDuringTime",acceldist,nonacceldist)
			return acceldist+nonacceldist
		end
	end
	
	
	local function GetDTAToNextGridVertex(player)
		local nextx,nexty=GetNextGridVertex(player)
		if(not nextx)then return nil end
		local dist
		-- if movespeed is positive, dist will be positive
		-- and vice versa, regardless of which direction player is facing.
		if(player.xdirection~=0)then
			dist=(nextx-player.x)*TRAININGGROUNDS_signum(player.xdirection)
		else
			dist=(nexty-player.y)*TRAININGGROUNDS_signum(player.ydirection)
		end
		local movetime=GetTimeBetweenPlayerAndDistance(player,dist)
		--print("DTAToNextGridVertex",player.x,player.y,nextx,nexty,movetime,dist)
		if(not movetime) then return nil end	
		if(movetime<0)then return nil end
		return {distance=dist,time=movetime,action=function() PlayerAtVertex(player,nextx,nexty) end,debug="VERTEX"..tostring(nextx)..","..tostring(nexty)}
	end	
	
	function PlayerAtVertex(player,vx,vy)	-- this is still local, since we declared it earlier...
		--print("PlayerAtVertex",vx,vy)
		--print("PlayerAtVertex",vx,vy,"speed:",player.currentmovespeed)
		player:AtVertex(vx,vy)
	end
	
	
	local function GetDTAToNextLongDist(player)
		-- this function works only for ADJACENT longdist interactions, not the one we're already in range of
		-- (which is one of the reasons why we check every frame to see if the player is already in range)
		local nextx,nexty=GetNextGridVertex(player)
		if(not nextx)then return nil end
		local sphere=player.scenario.grid:GetSphereAt(nextx,nexty)
		if(not sphere)then return nil end
		local interactdistance=sphere.interact_distance
		if(not interactdistance)then return nil end
		if(player:IsIgnoringSameVertex(sphere))then	return nil end	
		if(player:IsIgnoringThisLongrangeSphere(sphere))then return nil end				
		local dist
		-- if movespeed is positive, dist will be positive
		-- and vice versa, regardless of which direction player is facing.		
		if(player.xdirection~=0)then
			dist=(nextx-player.x)*TRAININGGROUNDS_signum(player.xdirection)
		else
			dist=(nexty-player.y)*TRAININGGROUNDS_signum(player.ydirection)
		end
		-- next, subtract sphere's interactdistance from the remaining distance.
		-- this is expected to shorten the remaining distance, whether dist is positive or negative.
		
		dist=dist-interactdistance*TRAININGGROUNDS_signum(dist)
		
		local movetime=GetTimeBetweenPlayerAndDistance(player,dist)
		--print("DTAToNextLongDist",player.x,player.y,nextx,nexty,movetime,dist)
		if(not movetime) then return nil end	
		if(movetime<0)then return nil end
		return {distance=dist,time=movetime,action=function() 
				player:InteractAtLongDistance(sphere) 				
			end,debug="LONG_DISTANCE"}
		
	end

	
	local function GetDTAToNextAccelBreakpoint(player)
		if(not player.accelerating)then return nil end		
	end
	
	local function GetDTAToJumpCooldown(player)		
		if(not player:IsJumpOnCooldown()) then return nil end
		local movetime=player.jumpcooldownendtime-player.currenttime
		local distance=GetPlayerDistanceCoveredDuringTime(player,movetime)		
		return {distance=distance,time=movetime,action=function() player.jumpcooldownendtime=nil end, debug="JUMPCOOLDOWN ENDS"}
	end

	local function GetDTAToEndJump(player)		
		if(not player.endjumptime) then return nil end
		local movetime=player.endjumptime-player.currenttime
		-- although we calculate distance here, 
		-- if player.projectedjumpendx/y isn't nil, EndJump will snap to that location instead
		local distance=GetPlayerDistanceCoveredDuringTime(player,movetime)		
		return {distance=distance,time=movetime,action=function() player:EndJump() end, debug="JUMPEND"}
	end	
	
	
	function GetTimeToCoverDistanceGivenConstantAccel(player,distance)	--already declared local
		--1/2accel*t^2 + init_speed*t - distance = 0
		local accel=player:GetCurrentAccelerationRate()
		if(accel==0)then
			--TODO LATER: decide whether to error here or return infinity
			--error("Assertion failed: can't call GetTimeToCoverDistanceGivenConstantAccel if accel is zero")			
		end
		local init_speed=player.currentmovespeed
		local a=0.5*accel
		local b=init_speed
		local c=-distance
		local t1,t2=TRAININGGROUNDS_QuadraticFormula(a,b,c)
		--print("Quadratic formula results:",t1,t2)
		-- normally we expect one positive, one negative, and we take the positive time as the answer.
		-- however, if the player is moving backwards but accelerating forwards,
		-- we expect both times will be positive, in which case we want the lower of the two times...
		if(t1<0 and t2>=0)then
			return t2
		end
		if(t2<0 and t1>=0)then
			return t1
		end
		if(t1>=0 and t2>=0)then
			return math.min(t1,t2)
		end
		--error("Assertion failed: time>0")
		return nil
	end
	
	-- no longer used
	-- function CanPlayerCoverDistanceWhileSkidding(player,distance) -- already declared local
		-- --this function applies only when the player is moving backwards but accelerating forwards.
		-- if(player.currentmovespeed>=0)then return true end
		-- if(not player.accelerating)then return true end		
		-- -- provided both of those are true, calc how far the player will move before skidding to a stop.
		-- local DTA=CalcAccelBreakpoint(player)
		-- if(math.abs(DTA.distance)>=math.abs(distance))then 
			-- return true
		-- else
			-- return false
		-- end
	-- end
	
	
	local function AccelerateIfApplicable(player,movetime)
		if(player.accelerating)then
			-- -- note that the reported movespeed will be inaccurate if we call an accel breakpoint function later this frame
			--print("Movespeed changing from",player.currentmovespeed,"to",player.currentmovespeed+player:GetCurrentAccelerationRate()*movetime)
			--print("details:",player:GetCurrentAccelerationRate(),movetime)					
			player.currentmovespeed=player.currentmovespeed+player:GetCurrentAccelerationRate()*movetime
		else
			--print("No longer accelerating.",player.currentmovespeed)
		end
		----WARNING: don't do the following.  this should be handled by ReachedAccelBreakpoint instead
		-- if(player.currentmovespeed>player:GetMaxSpeed())then
			-- player.currentmovespeed=player:GetMaxSpeed()
		-- end
	end	
	local function MoveDistance(player,distance)
		--print("Moving player",distance,"units")
		player.x=player.x+player.xdirection*distance
		player.y=player.y+player.ydirection*distance
		player.backgroundmovement=player.backgroundmovement+distance
	end
	local function AdvanceTimer(player,movetime)
		--print("Advancing timer",movetime)
		if(movetime>=0)then
			-- movetime could legitimately be less than zero if, for example,
			-- we were in the middle of a turn when the intro state timed out
			player.remainingmovetime=player.remainingmovetime-movetime
			player.currenttime=player.currenttime+movetime		
		else
			--TODO: assertion failed
			-- (this is one of the more important assertion faileds)
			--  (bad things happen if we subtract negative movetime from remainingmovetime)
			--    (turn-during-intro-teleports-us-forward sorts of things)
		end
	end	
	local function TurnAtAngle(player,angle)
		--print("Turning player",angle)
		player.grid_facing=player.grid_facing+angle*player.turndirection
		player.remainingturnangle=player.remainingturnangle-angle
	end
	
	
	function move.SubMovement(player)
	
		
		if(player.wincondition==0)then
			player.scenario.controls:CheckPlayerInput()
		end
	
		--print("Remaining move time this segment + player position:",player.remainingmovetime,player.x,player.y)
		local sphere,nextsphere
		local grid=player.scenario.grid
	
		move.nearestmovetarget=nil

		if(player.introendtime and player.introendtime<=player.currenttime)then
			player:EndIntro()
		end
		
		if(player.endjumptime)then
			player.ignore_same_vertex=false
			player.ISVx=nil
			player.ISVy=nil
			player.ignore_longrange_bumpers=false
			player.ILBx=nil
			player.ILBy=nil		
			if(player.accelerating)then
				--TODO LATER: during skidstop, player is technically NOT accelerating, so do we need to check for skidstop, or is it impossible to get into a situation where that would make a difference?
				player.projectedjumpendx=nil
				player.projectedjumpendy=nil
			end		
		end
		
		-- State check.  It should probably be rewritten.
				--"DTA" stands for "distance/time/action".
				-- the expectation is that we find the minimum of distance or time,
				-- then adjust player's position and maybe run a function and/or interact with a sphere.
				-- Invalid or inapplicable DTAs are nil.
		if(player.turning)then
			--print("State: turning")
			--"ATA" stands for "angle/time/action".
			--TODO: maybe rename to DTA/ATA to TDA/TAA, since we primarily compare time instead of distance?
			local ata_doneturning={angle=player.remainingturnangle,time=player.remainingturnangle/player.turnspeed,action=function()player:DoneTurning()end,debug="DONE TURNING" }
			local turnspeed=player.turnspeed
			if(player.goalout)then ata_doneturning=nil;turnspeed=player.goaloutturnspeed end			
			local ata_remainingmovetime={angle=player.remainingmovetime*turnspeed,time=player.remainingmovetime,action=nil,debug="REMAINING"}
			local lowest_time_ata=GetMinimumNotNilTime(ata_doneturning,ata_remainingmovetime)
			--print("Turn1",player.remainingmovetime)
			DebugPrintDTA("Turning",lowest_time_ata)
			TurnAtAngle(player,lowest_time_ata.angle)
			AdvanceTimer(player,lowest_time_ata.time)			
			if(lowest_time_ata.action)then lowest_time_ata.action() end
			
			--normally player can't jump during a turn, but this changes during goalout
				-- we don't need to use DTA/ATA during goalout
			if(player.goalout)then
				if(player.endjumptime) then 
					if(player.endjumptime<=player.currenttime)then
						player:EndJump()
					end
				end
			end
			
		elseif(player.skidstopendtime)then
			-- first, check for the unlikely but still possible scenario that the player skidstopped in midair and landed on something
			if(player.endjumptime==nil)then							
				sphere=AlreadyInRangeOfNextInteractionPoint(player)				
			end
			if(sphere)then
				--print("skidstop AIR:",sphere,sphere.x,sphere.y)
				player:InteractAtLongDistance(sphere)	
			else
			--
				local dta_endjump=GetDTAToEndJump(player)
				local dta_nextjump=GetDTAToJumpCooldown(player)
				local dta_skidstopendtime={time=player.skidstopendtime-player.currenttime,distance=0,action=function()SkidStopDone(player)end,debug="SKIDSTOPDONE"}
				local dta_remainingmovetime={time=player.remainingmovetime,distance=0,action=nil,debug="REMAINING"}
				local lowest_time_dta=GetMinimumNotNilTime(dta_endjump,dta_nextjump,dta_skidstopendtime,dta_remainingmovetime)
				-- no need to accelerate or move during skidstop
				-- just advancetimer+action here			
				AdvanceTimer(player,lowest_time_dta.time)				
				if(lowest_time_dta.action)then
					lowest_time_dta.action()
				end			
			end
		elseif(player.endjumptime)then
			--print("State: jumping")
			
			-- we have to track nextvertex in case player very recently hit a bumper;
			-- if we don't track this, player would be unable to input forward until they hit the ground again
			local dta_endintro=nil
			if(player.introendtime)then
				dta_endintro={time=player.introendtime-player.currenttime,distance=0,action=function()player:EndIntro()end}			
			end
			local dta_nextvertex=GetDTAToNextGridVertex(player)
			local dta_nextaccelbreakpoint=CalcAccelBreakpoint(player)	
			local dta_endjump=GetDTAToEndJump(player)
			local dta_remainingmovetime={time=player.remainingmovetime,distance=GetPlayerDistanceCoveredDuringTime(player,player.remainingmovetime),action=nil,debug="REMAINING"}
			local lowest_time_dta=GetMinimumNotNilTime(dta_nextvertex,dta_nextaccelbreakpoint,dta_endjump,dta_remainingmovetime)
			DebugPrintDTA("Jumping",lowest_time_dta)
			AccelerateIfApplicable(player,lowest_time_dta.time)
			MoveDistance(player,lowest_time_dta.distance)
			AdvanceTimer(player,lowest_time_dta.time)				
			if(lowest_time_dta.action)then
				lowest_time_dta.action()
			end			
			
			
		elseif(player.intro)then
			-- never start the player on top of a sphere -- undefined behavior might happen
			--print("State: intro")
			-- During intro state, player can turn and jump.
			-- jumping is handled by CheckPlayerInput at the start of the submovement loop,
			-- but turning is handled from within this state
			-- so we need to check remaining intro time before turning
			-- or else the player can hang indefinitely in the turning loop
			
			-- (and exit the intro state)
			--TODO: can we combine intro+normal state?  we would need to handle turning w/o crossing vertex
			
			if(player.introendtime)then--TODO: player.introendtime should only be nil if player.intro==false
				--print("intro remaining:",player.introendtime-player.currenttime)
				if(player.introendtime>player.currenttime)then
					player:CheckTurnQueueAndStartTurning()		
					if(player.turning)then return end				
				end
			end

			local dta_endintro=nil
			if(player.introendtime)then	--TODO: why would player.introendtime ever be nil during player.intro?
				local remainingintrotime=player.introendtime-player.currenttime
				if(remainingintrotime<0)then remainingintrotime=0 end
				dta_endintro={time=remainingintrotime,distance=0,action=function()player:EndIntro()end}							
			end
			local dta_nextjump=GetDTAToJumpCooldown(player)
			local dta_remainingmovetime={time=player.remainingmovetime,distance=0,action=nil,debug="REMAINING"}			
			
			local lowest_time_dta=GetMinimumNotNilTime(dta_endintro,dta_nextjump,dta_remainingmovetime)
			-- (NOTE: player exiting intro early by pressing FORWARD is handled via player:AttemptForward)		
			AdvanceTimer(player,lowest_time_dta.time)				
			if(lowest_time_dta.action)then
				lowest_time_dta.action()
			end			

		else
			sphere=AlreadyInRangeOfNextInteractionPoint(player)
			if(sphere)then
				--print("ALREADY IN RANGE")
				player:InteractAtLongDistance(sphere)				
			else
				local dta_nextvertex=GetDTAToNextGridVertex(player)
				--if(dta_nextvertex)then print("Vertex:",dta_nextvertex.distance,dta_nextvertex.time) end
				local dta_nextlongdist=GetDTAToNextLongDist(player)
				--if(dta_nextlongdist)then print("Longdist:",dta_nextlongdist.distance,dta_nextlongdist.time) end
				local dta_nextjump=GetDTAToJumpCooldown(player)
				--if(dta_nextjump)then print("Jump cooldown:",dta_nextjump.distance,dta_nextjump.time) end
				local dta_nextaccelbreakpoint=CalcAccelBreakpoint(player)	
				--if(dta_nextaccelbreakpoint)then print("Breakpoint:",dta_nextaccelbreakpoint.distance,dta_nextaccelbreakpoint.time) end
				--TODO: move the entire remainingmovetime thing into one function, which returns a DTA, like the others do?
				local dta_remainingmovetime={time=player.remainingmovetime,distance=GetPlayerDistanceCoveredDuringTime(player,player.remainingmovetime),action=nil,debug="REMAINING"}
				--if(dta_remainingmovetime)then print("Remaining:",dta_remainingmovetime.distance,dta_remainingmovetime.time) end
				
				
								
				local lowest_time_dta=GetMinimumNotNilTime(dta_nextvertex,dta_nextlongdist,dta_nextjump,dta_nextaccelbreakpoint,dta_remainingmovetime)
				
				--lowest_time_dta should never be nil here as we've passed it dta_remainingmovetime								
				DebugPrintDTA("Standard",lowest_time_dta)
				AccelerateIfApplicable(player,lowest_time_dta.time)
				MoveDistance(player,lowest_time_dta.distance)
				AdvanceTimer(player,lowest_time_dta.time)				
				if(lowest_time_dta.action)then
					lowest_time_dta.action()
				end
				--print("-----------")

				
				if(math.abs(lowest_time_dta.distance)>1)then
					if(true)then
						--TODO: we should at least let the player know that something went wrong
						--error("Assertion failed: lowest_time_dta.distance>1 (something went terribly wrong)")
					end
				end

				
			end
		end
		
		--running-forward phase
		local next_sphere_x_modifier=TRAININGGROUNDS_signum(player.xdirection*player.speedmultiplier)
		local next_sphere_y_modifier=TRAININGGROUNDS_signum(player.ydirection*player.speedmultiplier)
		
		--while moving, check for:
		-- distance until player.remainingtime<=0
		-- distance until player accelerates to 0 speed (from negative speed)
		-- distance until player accelerates to max speed
		-- distance until next jump (if a jump is queued)
		-- distance until next orb interaction distance (if applicable)
		-- distance until next vertex
		--then move to the closest of those points
	end	
	
end
