
do
	local super=TRAININGGROUNDS_ScenarioPlayerControls
	TRAININGGROUNDS_SECRET35_ScenarioPlayerControls = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SECRET35_ScenarioPlayerControls

	function class:GetPlayerInput(elapsed)
		-- don't call super 
		--TODO: might have to call super after we rewrite base ScenarioPlayerControls class		
		
		-- DON'T call CheckPlayerInput here -- we call it from movement module instead
		--self:CheckPlayerInput()
	end
	
	--public-ish function.  instead of calling this at the start of each frame,
	-- we call this at the start of each of the player's SUBMOVEMENT steps.
	function class:CheckPlayerInput()
		--"pressed" should no longer fail at low framerates
		--conversely, it's possible for a key to be pressed and released on the same frame.  beware.
		if(self.environment.game.keys.jump.pressed)then
			--print("jump...")
			self.scenario.player:JumpInput()
		end	
		-- the player has 1.0/60 seconds leeway on the jump key.  check if it's been that long
		-- (reminder that we call CheckPlayerInput during every submovement state change,
		-- though the actual hardware input won't update until the next frame)
		if(self.scenario.player.jumpinputtime and (self.scenario.player.jumpinputtime+self.scenario.player.jumpinputduration>=self.scenario.player.currenttime))then
			self.scenario.player:AttemptToQueueJump()
		end
		-- the player also has a frame or two leeway regardless of framerate.
		-- TODO LATER: (this is supposed to be exactly one extra frame -- if it's two extra, fix it)
		if(self.scenario.player.jumpinputremainingframes>0)then
			self.scenario.player:AttemptToQueueJump()
		end
		if(self.scenario.player.jumpqueued)then
			self.scenario.player:AttemptQueuedJump()
		end


		local environment_gameplay=self.environment.game.environment_gameplay
		
		local vectorx,vectory=0,0
		-- there is still some indecision over the best way to handle "but what if the player presses both directions at once"
		if(self.environment.game.keys.leftA.pressed or self.environment.game.keys.left.pressed)then
			vectorx=vectorx-1
		end		
		if(self.environment.game.keys.rightD.pressed or self.environment.game.keys.right.pressed)then
			vectorx=vectorx+1
		end			
		if(self.environment.game.keys.leftA.current or self.environment.game.keys.left.current)then
			vectorx=vectorx-1
		end		
		if(self.environment.game.keys.rightD.current or self.environment.game.keys.right.current)then
			vectorx=vectorx+1
		end							
		if(vectorx~=0)then
			self.scenario.player:AttemptQueueTurn(TRAININGGROUNDS_signum(vectorx))
		end		
		
		if(self.environment.game.keys.downS.pressed)then			
			--print("downS")
		end	
		if(self.environment.game.keys.upW.pressed or self.environment.game.keys.upW.current
		 or self.environment.game.keys.up.pressed or self.environment.game.keys.up.current)then
			self.scenario.player:AttemptForward()
		end
	end
	
	
end

