
do
	local super=TRAININGGROUNDS_Scenario
	TRAININGGROUNDS_SECRET35_Scenario_35Spheres = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SECRET35_Scenario_35Spheres
	
	function class:CreatePlayerControls()
		local controls = TRAININGGROUNDS_SECRET35_ScenarioPlayerControls.new()
		controls:Setup(self.environment,self)			
		self.controls=controls
	end
	
	function class:Populate()
		super.Populate(self)						
		
		if(self.inversemode==nil)then self.inversemode=false end
		
		--TODO: custom environment maybe?
		local env_gameplay=self.environment.game.environment_gameplay
		
		
		
		env_gameplay.cameramanager.camera:Cleanup()
		local camera=TRAININGGROUNDS_SECRET35_Camera_35Spheres.new()
		camera:Setup(env_gameplay)
		env_gameplay.cameramanager:HookUpCamera(camera)
		
		
		local hedge=TRAININGGROUNDS_SECRET35_GameObject_Runner35.new()
		hedge:Setup(env_gameplay,self)
		self.player=hedge		
		local hedgeshadow=TRAININGGROUNDS_SECRET35_GameObject_Shadow35.new()
		hedgeshadow:Setup(env_gameplay)
		
		
		local follower=TRAININGGROUNDS_SECRET35_GameObject_Follower35.new()
		follower:Setup(env_gameplay,self)
		self.follower=follower
		follower.hedge=hedge
		hedge.follower=follower
		local followershadow=TRAININGGROUNDS_SECRET35_GameObject_Shadow35_Follower.new()
		followershadow:Setup(env_gameplay)		
		followershadow.y=-10
		
		
		local grid=TRAININGGROUNDS_SECRET35_GameObject_WorldGrid.new()
		grid:Setup(env_gameplay)
		--TODO NEXT: adjust 3D camera position instead		
		grid.x=0;grid.y=0 -- -250
		self.grid=grid
		
			
		local background=TRAININGGROUNDS_SECRET35_GameObject_ScrollingBackground.new()
		background:Setup(env_gameplay,hedge)	
		self.background=background
		----G_BACK=background
		----/run TRAININGGROUNDS_FrameVisibilityCheck(G_BACK.drawable.frame)

		TRAININGGROUNDS_SECRET35_GridLayouts_SetupWorld(self)
		
		local hudleft=TRAININGGROUNDS_SECRET35_HUDLeft.new()
		hudleft:Setup(env_gameplay)
		hudleft:CountSpheres(self.grid)
		self.grid.hudleft=hudleft
		local hudright=TRAININGGROUNDS_SECRET35_HUDRight.new()
		hudright:Setup(env_gameplay)
		self.grid.hudright=hudright
		
		local banner
		if(not self.inversemode)then
			banner=TRAININGGROUNDS_SECRET35_Banner_GBS.new()
		else
			banner=TRAININGGROUNDS_SECRET35_Banner_GRS.new()
		end
		banner:Setup(env_gameplay)
		
		
		
	end	
	
	
	--TRAININGGROUNDS_ScenarioList.RegisterScenario(TRAININGGROUNDS_SECRET35_Scenario_35Spheres,"Spheres scenario for Secret 35","NOTHING TO SEE HERE.  MOVE ALONG")
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		
		if(self.player and self.grid)then
			if(self.player.wincondition==1)then
				self.grid.billboard_height=self.grid.billboard_height+2*elapsed
				local MAX_HEIGHT=5
				if(self.grid.billboard_height>MAX_HEIGHT)then 
					self.grid.billboard_height=MAX_HEIGHT 
					self.grid:PlaceEmerald(self.player)
					self.player.wincondition=2
					self.grid.billboard_height=0
					self.player:ResetToWinConditionSpeed()
				end
			end
		end
	end
	
	function class:OnEscapeKey()
		local menu=self.environment.game:LoadScenarioByClass(TRAININGGROUNDS_SECRET35_Scenario_35SpheresMenu)
		menu.inversemode=self.inversemode
	end	
	
	
	
	--TRAININGGROUNDS_ScenarioList_Minigames:RegisterScenario(TRAININGGROUNDS_SECRET35_Scenario_35Spheres,"Get Spheres","A dizzying test of precise timing and quick reflexes!")
end