TRAININGGROUNDS_Secret35_Struct_Sphere_DrawDataList={}
TRAININGGROUNDS_Secret35_Struct_Sphere_DrawDataList.PLACEHOLDER=0
TRAININGGROUNDS_Secret35_Struct_Sphere_DrawDataList.GET={
	file="Interface\\AddOns\\TrainingGrounds_GetSpheres\\Assets\\Graphics\\rendertest_colors.tga",
	offset=1}
TRAININGGROUNDS_Secret35_Struct_Sphere_DrawDataList.GOAL={
	file="Interface\\AddOns\\TrainingGrounds_GetSpheres\\Assets\\Graphics\\rendertest_colors.tga",
	offset=0}
TRAININGGROUNDS_Secret35_Struct_Sphere_DrawDataList.BUMPER={
	file="Interface\\AddOns\\TrainingGrounds_GetSpheres\\Assets\\Graphics\\rendertest_springs.tga",
	offset=0}
TRAININGGROUNDS_Secret35_Struct_Sphere_DrawDataList.SPRING={
	file="Interface\\AddOns\\TrainingGrounds_GetSpheres\\Assets\\Graphics\\rendertest_springs.tga",
	offset=1}	
TRAININGGROUNDS_Secret35_Struct_Sphere_DrawDataList.RING={
	file="Interface\\AddOns\\TrainingGrounds_GetSpheres\\Assets\\Graphics\\rendertest_rings.tga",	
	offset=0}
TRAININGGROUNDS_Secret35_Struct_Sphere_DrawDataList.EMERALD={
	file="Interface\\AddOns\\TrainingGrounds_GetSpheres\\Assets\\Graphics\\rendertest_rings.tga",	
	offset=1}
TRAININGGROUNDS_Secret35_Struct_Sphere_DrawDataList.RINGSPARKLES={
	file="Interface\\AddOns\\TrainingGrounds_GetSpheres\\Assets\\Graphics\\rendertest_ringsparkles.tga",
	offset=0}

do
	TRAININGGROUNDS_Secret35_Struct_Sphere = {}
	TRAININGGROUNDS_Secret35_Struct_Sphere.__index = TRAININGGROUNDS_Secret35_Struct_Sphere

	local class=TRAININGGROUNDS_Secret35_Struct_Sphere

	function class.new()
		local self=setmetatable({}, class)		
		return self
	end

	function class:Setup(grid,x,y)
		self.grid=grid
		self.x=x
		self.y=y
		self.flashendtime=nil
		self.grid.grid_contents[x][y]=self
		self.floodfillmarked=false
		self.postfloodfillringmarked=false
		-- interact_distance must never be higher than 4/8.0,
		-- otherwise the sphere will extend out to the adjacent grid vertex
		-- and calculations will break down.
		self.interact_distance=2.5/8.0
		self.ringindexoffset=math.floor(math.random()*32)+1
	end
	
	function class:IsANil()
		return false
	end
	
	function class:IsABumper()
		return false
	end
	
	function class:IsARing()
		return false
	end	
	
	function class:IsASparkle()
		return false
	end
	
	function class:IsAFloodfillOrigin()
		return false
	end
	
	function class:IsAGoalSphere()
		return false
	end
	
	function class:IsAGetSphere()
		return false
	end
	
	function class:GetRingIndex(currenttime)
		return (self.ringindexoffset+math.floor(currenttime*30))%32+1
	end
		
	function class:OnInteract(player)
		print("TRAININGGROUNDS_Secret35: pure virtual sphere was not overridden properly")
		--error("pure virtual sphere was not overridden properly")
		player:IgnoreSameVertex()
		self.flashendtime=player.environment.localtime+0.5
	end
	
	function class:GetDrawData(currenttime,scenario)
		return TRAININGGROUNDS_Secret35_Struct_Sphere_DrawDataList.PLACEHOLDER
	end
	
	function class:GetSizeMultiplier()
		return 1
	end	
end


do
	local super=TRAININGGROUNDS_Secret35_Struct_Sphere
	TRAININGGROUNDS_Secret35_Struct_Sphere_Nil=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_Secret35_Struct_Sphere_Nil

	function class:Setup(grid,x,y)
		super.Setup(self,grid,x,y)
	end	
	function class:IsANil()
		return true
	end
	function class:IsAFloodfillOrigin()
		return true
	end
	
	function class:OnInteract(player)
		-- do nothing
		player:IgnoreSameVertex()
	end
end

do
	local super=TRAININGGROUNDS_Secret35_Struct_Sphere
	TRAININGGROUNDS_Secret35_Struct_Sphere_Get=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_Secret35_Struct_Sphere_Get

	function class:Setup(grid,x,y)
		super.Setup(self,grid,x,y)
		--self.interact_distance=2.5/8.0	
		---- our testing indicates 2.5 SHOULD be correct, but stage-4 messes up unless it's at least 3
		self.interact_distance=3.0/8.0	
	end
	
	function class:IsAFloodfillOrigin()
		return false
	end
	
	function class:OnInteract(player)	
		--print("Debug: sphere_get")
		player:IgnoreSameVertex()
		if(player:InteractsWithSpheres())then
			self.flashendtime=player.environment.localtime+0.5
			local goalsphere=TRAININGGROUNDS_Secret35_Struct_Sphere_Goal.new()
			goalsphere:Setup(self.grid,self.x,self.y)
			goalsphere.colorchange_time=player.currenttime+7/60.0		
			self.grid:RingOutlineCheck(self.x,self.y)
			
			local spherecount=self.grid.hudleft:CountSpheres(self.grid)
			if(spherecount==0)then
				player.wincondition=1
				local scenario=self.grid.environment.game.scenario
				if(not scenario.inversemode)then
					if(self.grid.hudright.total>=scenario.perfectringcount)then
						TRAININGGROUNDS_UNLOCKRACE35_SAVEDATA.clear[scenario.stagenumber]=2
					else
						if(TRAININGGROUNDS_UNLOCKRACE35_SAVEDATA.clear[scenario.stagenumber]~=2)then
							TRAININGGROUNDS_UNLOCKRACE35_SAVEDATA.clear[scenario.stagenumber]=1
						end
					end
				else
					if(self.grid.hudright.total>=scenario.inverseperfectringcount)then
						TRAININGGROUNDS_UNLOCKRACE35_SAVEDATA.inverseclear[scenario.stagenumber]=2
					else
						if(TRAININGGROUNDS_UNLOCKRACE35_SAVEDATA.inverseclear[scenario.stagenumber]~=2)then
							TRAININGGROUNDS_UNLOCKRACE35_SAVEDATA.inverseclear[scenario.stagenumber]=1
						end
					end				
				end
			end
		end
	end
	
	function class:IsAGetSphere()
		return true
	end	
	
	function class:GetDrawData(currenttime,scenario)
		if(not scenario.inversemode)then
			return TRAININGGROUNDS_Secret35_Struct_Sphere_DrawDataList.GET
		else
			return TRAININGGROUNDS_Secret35_Struct_Sphere_DrawDataList.GOAL
		end
	end	
end

do
	local super=TRAININGGROUNDS_Secret35_Struct_Sphere
	TRAININGGROUNDS_Secret35_Struct_Sphere_Goal=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_Secret35_Struct_Sphere_Goal

	function class:Setup(grid,x,y)
		super.Setup(self,grid,x,y)
		self.interact_distance=nil
		self.colorchange_time=nil
	end
	
	function class:OnInteract(player)	
		self.flashendtime=player.environment.localtime+0.5	
		if(player:InteractsWithSpheres())then
			--TODO: scenario failure state
			player:StartGoalout()			
		end
	end

	function class:IsAFloodfillOrigin()
		return false
	end
	
	function class:IsAGoalSphere()
		return true
	end
	
	function class:GetDrawData(currenttime,scenario)
		
		if((not self.colorchange_time)
		or (not currenttime)
		or (currenttime>self.colorchange_time))then
			if(not scenario.inversemode)then
				return TRAININGGROUNDS_Secret35_Struct_Sphere_DrawDataList.GOAL
			else
				return TRAININGGROUNDS_Secret35_Struct_Sphere_DrawDataList.GET
			end			
		else
			if(not scenario.inversemode)then
				return TRAININGGROUNDS_Secret35_Struct_Sphere_DrawDataList.GET
			else
				return TRAININGGROUNDS_Secret35_Struct_Sphere_DrawDataList.GOAL
			end
		end
	end	
end

do
	local super=TRAININGGROUNDS_Secret35_Struct_Sphere
	TRAININGGROUNDS_Secret35_Struct_Sphere_Ring=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_Secret35_Struct_Sphere_Ring

	function class:Setup(grid,x,y)
		super.Setup(self,grid,x,y)
		self.interact_distance=2.5/8.0
	end
	
	function class:OnInteract(player)		
		--print("Debug: sphere_ring")
		
		--self.grid.grid_contents[self.x][self.y]=nil
		--TODO: instead of clearing grid vertex, place sparkles here
		-- self.flashendtime=player.environment.localtime+0.5
		player:IgnoreSameVertex()	--note: rings ignore ISV unless wincondition is true
		if(player:InteractsWithSpheres())then		
			local goalsphere=TRAININGGROUNDS_Secret35_Struct_Sphere_Sparkle.new()
			goalsphere:Setup(self.grid,self.x,self.y)
			goalsphere.colorchange_time=player.currenttime+45.0/60.0		
			
			local ringcount=self.grid.hudright:IncrementRings(self.grid)
			local scenario=self.grid.environment.game.scenario
			local perfect=scenario.perfectringcount
			if(scenario.inversemode)then perfect=scenario.inverseperfectringcount end
			if(ringcount==perfect)then	--TODO: self.grid.perfectringcount
				local bannerperfect=TRAININGGROUNDS_SECRET35_Banner_Perfect.new()		
				bannerperfect:Setup(self.grid.environment)
			end
			
			--print("debug:true")
		else
			--print("debug:false",GetTime())
		end
	end
	
	function class:IsARing(player)
		return true
	end
	function class:IsAFloodfillOrigin()
		return true
	end
	
	
	function class:GetDrawData(currenttime,scenario)
		return TRAININGGROUNDS_Secret35_Struct_Sphere_DrawDataList.RING
	end	
end

do
	local super=TRAININGGROUNDS_Secret35_Struct_Sphere
	TRAININGGROUNDS_Secret35_Struct_Sphere_Sparkle=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_Secret35_Struct_Sphere_Sparkle

	function class:Setup(grid,x,y)
		super.Setup(self,grid,x,y)
		self.interact_distance=nil
	end
	
	function class:OnInteract(player)		
		--do nothing
		player:IgnoreSameVertex()
	end
	
	function class:IsASparkle()
		return true
	end
	
	function class:GetRingIndex(currenttime)		
		return (self.ringindexoffset+math.floor(currenttime*15))%4+1
	end	
	
	function class:GetDrawData(currenttime,scenario)
		if((not self.colorchange_time)
		or (not currenttime)
		or (currenttime>self.colorchange_time))then
			--self.grid.grid_contents[self.x][self.y]=nil
			local nilsphere=TRAININGGROUNDS_Secret35_Struct_Sphere_Nil.new()
			nilsphere:Setup(self.grid,self.x,self.y)
		end
		return TRAININGGROUNDS_Secret35_Struct_Sphere_DrawDataList.RINGSPARKLES
	end	
end


do
	local super=TRAININGGROUNDS_Secret35_Struct_Sphere
	TRAININGGROUNDS_Secret35_Struct_Sphere_Bumper=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_Secret35_Struct_Sphere_Bumper

	function class:Setup(grid,x,y)
		super.Setup(self,grid,x,y)
		--self.interact_distance=3.5/8.0
		--self.interact_distance=2.5/8.0
		self.interact_distance=3.0/8.0
	end
	
	function class:OnInteract(player)		
		--print("Debug: sphere_bumper")
		
		player:IgnoreSameVertex()
		
		if(player:InteractsWithSpheres())then
			self.flashendtime=player.environment.localtime+0.5
			player:IgnoreLongrangeBumpers()
			player.currentmovespeed=-player.currentmovespeed
			player.bumperforwardwillfail=true
			player.BFWFx=self.x
			player.BFWFy=self.y
			
			if(player.bumpered)then
				player.bumpered=false
				player.targetspeedsignum=1
			else
				player.bumpered=true
				player.targetspeedsignum=-1
			end
		end
	end
	
	function class:IsABumper()
		return true
	end
	
	function class:GetDrawData(currenttime,scenario)
		return TRAININGGROUNDS_Secret35_Struct_Sphere_DrawDataList.BUMPER
	end	
end

do
	local super=TRAININGGROUNDS_Secret35_Struct_Sphere
	TRAININGGROUNDS_Secret35_Struct_Sphere_Spring=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_Secret35_Struct_Sphere_Spring

	function class:Setup(grid,x,y)
		super.Setup(self,grid,x,y)
		--self.interact_distance=3.5/8.0
		--self.interact_distance=2.5/8.0
		self.interact_distance=3.0/8.0
	end
	
	function class:OnInteract(player)		
		if(player:InteractsWithSpheres())then
			--print("Debug: sphere_spring")
			self.flashendtime=player.environment.localtime+0.5
			--TODO: spring
			player.springed=true
			
			--if(player.jumpqueued)then print("debug: canceled queued jump!")	end
			-- if the player queued a normal jump just before hitting the spring, cancel it
			player.jumpqueued=false
			player.currentmovespeed=player.currentmovespeed*2
			local effectivespeedmultiplier=player:EffectiveSpeedMultiplier()			
			player.startjumptime=player.currenttime
			player.endjumptime=player.startjumptime+(48.0/60)/effectivespeedmultiplier
			player.projectedjumpendx=player.x+6*TRAININGGROUNDS_signum(player.currentmovespeed)*player.xdirection
			player.projectedjumpendy=player.y+6*TRAININGGROUNDS_signum(player.currentmovespeed)*player.ydirection	
			player.follower:QueueSpring()
		else
			player:IgnoreSameVertex()
		end
	end
	
	function class:GetDrawData(currenttime,scenario)
		return TRAININGGROUNDS_Secret35_Struct_Sphere_DrawDataList.SPRING
	end	

	function class:IsAFloodfillOrigin()
		return true
	end	
end


do
	local super=TRAININGGROUNDS_Secret35_Struct_Sphere
	TRAININGGROUNDS_Secret35_Struct_Sphere_Emerald=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_Secret35_Struct_Sphere_Emerald

	function class:Setup(grid,x,y)
		super.Setup(self,grid,x,y)
		self.interact_distance=nil
	end
	function class:OnInteract(player)	
		player:StartGoalout()			
	end
	function class:GetSizeMultiplier()
		return 2
	end
	function class:GetDrawData(currenttime,scenario)
		return TRAININGGROUNDS_Secret35_Struct_Sphere_DrawDataList.EMERALD
	end	
end